000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT           
000200 ID DIVISION.                                                             
000300* LAST UPDATE ON 14 Aug 1995 AT 10:54:28 BY  VEND789 VERSION 01   *       
000400 PROGRAM-ID. ACIFIDX.                                                     
000500 AUTHOR. B. E. HAAN, Pennant Systems, IBM                                 
000600         H. Turetzky, HYDRA                                               
000700                                                                          
000800     NOTE: REQUIRES VS COBOL II.  This program is a sample exit           
000900     for ACIF (APKACIF,5648-062) demonstrating the use of the             
001000     ACIF index exit.                                                     
001100                                                                          
001200     This program must either be compiled with the NORENT option          
001300     or linked with IGZOPT with the RTEREUS option.                       
001400     (See VS COBOL II Application Programming Guide, SC26-4045).          
001500                                                                          
001600     This program creates a VSAM index (KSDS) from a MO:DCA               
001700     document index.  There are several ways to organize such an          
001800     index. This program assumes TLE records occur in                     
001900     heirarchical order, ie., most signficant first. One index            
002000     record will be created for each page (it is assumed that             
002100     the input index is at page level). We further assume that            
002200     the index is of the style created by ACIF (5648-062).                
002300                                                                          
002400     The values for all of the TLE attribute value triplets are           
002500     placed in the VSAM key, suffixed by a flag indicating if             
002600     the index is for a group or page, and a counter to                   
002700     guarantee uniqueness.  Since VSAM limits key length to 255,          
002800     and the value for any attribute value triplet can be 250             
002900     bytes, this scheme is will not handle all possible MO:DCA            
003000     indexes. However, for most purposes this length is adequate          
003100     to hold all the values being indexed.                                
003200                                                                          
003300     The data portion of the VSAM index record contains all of            
003400     the locating information (byte and record offsets) and other         
003500     information contained on the page and group IELs, so that            
003600     the MO:DCA index can be reconstructed from the VSAM file.            
003700                                                                          
003800     All of the TLE triplets are saved in the data portion of             
003900     the index record.                                                    
004000                                                                          
004100     For cases where this organization is inadequate, such as             
004200     TLEs containing long values, the necessity to search on              
004300     secondary index values, or a different structure in the              
004400     relationship of tag/value pairs, the index could be                  
004500     organized as a primary index using the group name, and               
004600     VSAM alternate indexes for each tag. A more flexible                 
004700     method would be DB2 tables, where unique relationships               
004800     can be defined between keys.                                         
004900                                                                          
005000     EJECT                                                                
005100 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                            
005200 DATE-WRITTEN. JUN 93.                                                    
005300 DATE-COMPILED.                                                           
005400 SECURITY. IBM SAMPLE CODE ONLY.                                          
005500*/**************************************************************/         
005600*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */         
005700*/*                                                            */         
005800*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */         
005900*/*                                                            */         
006000*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */         
006100*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */         
006200*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */         
006300*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */         
006400*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */         
006500*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */         
006600*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */         
006700*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */         
006800*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */         
006900*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */         
007000*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */         
007100*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */         
007200*/**************************************************************/         
007300 TITLE 'AFP INDEX PROCESSOR'.                                             
007400 ENVIRONMENT DIVISION.                                                    
007500 CONFIGURATION SECTION.                                                   
007600 SOURCE-COMPUTER. IBM-370.                                                
007700 OBJECT-COMPUTER. IBM-370.                                                
007800 INPUT-OUTPUT SECTION.                                                    
007900 FILE-CONTROL.                                                            
008000     SELECT AFPKEY-FILE          ASSIGN TO AFPKEY,                        
008100                                 ORGANIZATION INDEXED,                    
008200                                 ACCESS MODE DYNAMIC,                     
008300                                 FILE STATUS AFPKEY-STATUS                
008400                                             VSAM-STATUS,                 
008500                                 RECORD KEY KEY-KEY.                      
008600   EJECT                                                                  
008700 DATA DIVISION.                                                           
008800 FILE SECTION.                                                            
008900 FD  AFPKEY-FILE                 GLOBAL,                                  
009000     RECORD VARYING DEPENDING ON AFPKEY-LENGTH.                           
009100     COPY AFPKEY.                                                         
009200   EJECT                                                                  
009300 WORKING-STORAGE SECTION.                                                 
009400 77  PGMNAME                 PIC X(8) VALUE 'AFPINDEX'.                   
009500 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.                   
009600 77  ABEND-CODE              PIC 9(4) COMP VALUE 12.                      
009700 77  SF-CC                   PIC X    VALUE X'5A'.                        
009800 77  AFPKEY-LENGTH           PIC 9(8) COMP VALUE 8205.                    
009900 77  AFPKEY-STATUS           PIC XX.                                      
010000     88  AFPKEY-OK           VALUE '00'.                                  
010100 77  AFPKEY-STATUS-NUM       REDEFINES AFPKEY-STATUS                      
010200                             PIC 99.                                      
010300 77  INDEX-QUALIFIER         PIC 9(8) COMP VALUE ZERO.                    
010400 77  IEL-PAGE-COUNT          PIC 9(8) COMP VALUE ZERO.                    
010500 77  PAGE-GROUP              PIC X    VALUE 'G'.                          
010600 77  PAGE-PAGE               PIC X    VALUE 'P'.                          
010700 77  KEY-LEFT                PIC 9(4) BINARY.                             
010800 77  KEY-MAX                 PIC 9(4) BINARY VALUE 255.                   
010900 77  KEY-HDR-LENGTH          PIC 9(4) BINARY.                             
011000 77  KEY-PTR                 PIC 9(4) BINARY.                             
011100 77  COMMENT-ID              PIC X(13) VALUE 'MODIFIED BY: '.             
011200 77  IEL-PENDING-FLAG        PIC X    VALUE LOW-VALUE.                    
011300     88  IEL-PENDING         VALUE HIGH-VALUE.                            
011400 77  AFPINDEX-EOF-FLAG       PIC X    VALUE LOW-VALUE.                    
011500     88  AFPINDEX-EOF        VALUE HIGH-VALUE.                            
011600     SKIP1                                                                
011700 01  VSAM-STATUS.                                                         
011800     05  VSAM-RC                 PIC 9(4) COMP.                           
011900     05  VSAM-FCT-CODE           PIC 9(1) COMP.                           
012000     05  VSAM-FDBK-CODE          PIC 9(3) COMP.                           
012100     SKIP1                                                                
012200 01  DATE-DATA.                                                           
012300   05  RUN-DATE.                                                          
012400     10 RUN-YY                 PIC 99.                                    
012500     10 RUN-MM                 PIC 99.                                    
012600     10 RUN-DD                 PIC 99.                                    
012700   05  COMPILE-DATE.                                                      
012800     10  COMP-DATE             PIC X(8).                                  
012900     10  COMP-TIME             PIC X(12).                                 
013000   05  RUN-TIME.                                                          
013100     10  RUN-HH                PIC 99.                                    
013200     10  RUN-MM                PIC 99.                                    
013300     10  RUN-SS                PIC 99.                                    
013400     10  RUN-MS                PIC 99.                                    
013500     SKIP2                                                                
013600 01  BINARY-NUMBERS.                                                      
013700     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.              
013800     05  BIN4-X                  REDEFINES BIN-4                          
013900                                 PIC X(4).                                
014000     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.              
014100     05  BIN2-X                  REDEFINES BIN2.                          
014200         10  FILLER              PIC X.                                   
014300         10  BIN2-2              PIC X.                                   
014400     SKIP2                                                                
014500 01  COMMENT-TRIPLET.                                                     
014600     05  COMMENT-LEN         PIC X.                                       
014700     05  COMMENT-TYPE        PIC X.                                       
014800     05  COMMENT-DATA        PIC X(250).                                  
014900     SKIP2                                                                
015000 01  TRIPLET-DATA.                                                        
015100     05  TRIPLET-PTR             PIC 9(8) BINARY.                         
015200     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                         
015300* offset to start of attribute value                                      
015400     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.                 
015500* STRUCTURED FIELD DEFINITIONS                                            
015600     COPY STRFLDS SUPPRESS.                                               
015700 TITLE 'DATA PASSED FROM ACIF'.                                           
015800 LINKAGE SECTION.                                                         
015900                                                                          
016000 01  IDX-PARMS.                                                           
016100     05  IDX-UWORK           POINTER.                                     
016200     05  IDX-PFATTR          POINTER.                                     
016300     05  IDX-RECORD          POINTER.                                     
016400     05  IDX-RECORDLN        PIC 9(4) BINARY.                             
016500     05  IDX-REQUEST         PIC X.                                       
016600         88  IDX-USE         VALUE X'00'.                                 
016700         88  IDX-DELETE      VALUE X'01'.                                 
016800     05  IDX-EOF             PIC X.                                       
016900         88  IDX-NOTEOF      VALUE 'N'.                                   
017000         88  IDX-EOFLAG      VALUE 'Y'.                                   
017100                                                                          
017200 01  IDX-WORKA.                                                           
017300     05  IDX-FIRST-FLAG      PIC X.                                       
017400         88  IDX-FIRST       VALUE LOW-VALUE.                             
017500         88  IDX-NOTFIRST    VALUE HIGH-VALUE.                            
017600                                                                          
017700 01  AFPINDEX-RECORD.                                                     
017800     05  AFPINDEX-INTRODUCER.                                             
017900       10  AFPINDEX-CC       PIC X.                                       
018000       10  AFPINDEX-LEN-CHR  PIC XX.                                      
018100       10  AFPINDEX-RECLEN   REDEFINES AFPINDEX-LEN-CHR                   
018200                             PIC 9(4) COMP.                               
018300* NOTE:  9(4) COMP is used to get halfword integer, but COBOL             
018400* may restrict value to 9999. COBOL II compile-time parm                  
018500* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword             
018600* with no truncation (TRUNC(OPT) produces far better code).               
018700       10  AFPINDEX-TYPE     PIC XXX.                                     
018800       10  AFPINDEX-FLAG     PIC X.                                       
018900       10  AFPINDEX-SEQ-CHR  PIC XX.                                      
019000       10  AFPINDEX-SEQNUM   REDEFINES AFPINDEX-SEQ-CHR                   
019100                             PIC 9(4) COMP.                               
019200     05  AFPINDEX-DATA.                                                   
019300         10  AFPINDEX-ARRAY      OCCURS 8192,                             
019400                                 DEPENDING ON AFPINDEX-RECLEN,            
019500                                 INDEXED BY AFPINDEX-INDX,                
019600                                 PIC X.                                   
019700 TITLE 'INITIALIZATION AND MAIN LINE'.                                    
019800 PROCEDURE DIVISION USING IDX-PARMS.                                      
019900*  This program is an ACIF index exit. It creates a similar index         
020000* (AFPKEY) using a VSAM KSDS.  Each IEL starts a corresponding new        
020100* VSAM record, subsequent TLE records that REFERENCE the IEL are          
020200* also accumulated.  When the next IEL is encounterd THE prior IEL        
020300* and TLE's are written to a single VSAM record.                          
020400 000-MAINLINE.                                                            
020500     SET ADDRESS OF AFPINDEX-RECORD TO IDX-RECORD.                        
020600     SET ADDRESS OF IDX-WORKA TO IDX-UWORK.                               
020700     MOVE ZERO TO RETURN-CODE.                                            
020800     IF IDX-EOFLAG                                                        
020900      THEN                                                                
021000       CLOSE AFPKEY-FILE;                                                 
021100       DISPLAY PGMNAME 'COUNT OF INDEXED PAGES ', IEL-PAGE-COUNT;         
021200       GOBACK;                                                            
021300     END-IF.                                                              
021400                                                                          
021500     IF IDX-NOTFIRST                                                      
021600      THEN                                                                
021700       PERFORM 0200-PROCESS-INDEX;                                        
021800      ELSE                                                                
021900       PERFORM 0100-INITIALIZE;                                           
022000       SET IDX-NOTFIRST TO TRUE;                                          
022100       PERFORM 0200-PROCESS-INDEX;                                        
022200     END-IF.                                                              
022300     SKIP2                                                                
022400 0100-INITIALIZE.                                                         
022500     MOVE WHEN-COMPILED TO COMPILE-DATE.                                  
022600     ACCEPT RUN-DATE FROM DATE.                                           
022700     ACCEPT RUN-TIME FROM TIME.                                           
022800        SKIP2                                                             
022900     OPEN OUTPUT AFPKEY-FILE.                                             
023000        SKIP2                                                             
023100     IF (NOT AFPKEY-OK) THEN                                              
023200        DISPLAY PGMNAME,                                                  
023300                'AFPKEY  STATUS AFTER OPEN ' AFPKEY-STATUS;               
023400        DISPLAY ' ';                                                      
023500        MOVE ABEND-CODE TO RETURN-CODE;                                   
023600        GOBACK.                                                           
023700        SKIP2                                                             
023800     ADD LENGTH OF KEY-LOCATION-DATA                                      
023900         LENGTH OF KEY-IEL-LENGTH                                         
024000         LENGTH OF KEY-TLE-LENGTH                                         
024100         LENGTH OF KEY-KEY        GIVING                                  
024200         KEY-HDR-LENGTH.                                                  
024300        EJECT                                                             
024400 0200-PROCESS-INDEX.                                                      
024500     SET IDX-USE TO TRUE.                                                 
024600     EVALUATE AFPINDEX-TYPE;                                              
024700      WHEN SF-BDI                                                         
024800       PERFORM 2000-INIT-INDEX;                                           
024900      WHEN SF-IEL                                                         
025000       IF IEL-PENDING                                                     
025100        THEN                                                              
025200         PERFORM 1100-WRITE-AFPKEY;                                       
025300       END-IF;                                                            
025400       PERFORM 3000-PROCESS-IEL;                                          
025500       SET IEL-PENDING TO TRUE;                                           
025600      WHEN SF-TLE                                                         
025700       PERFORM 4000-PROCESS-TLE;                                          
025800      WHEN SF-EDI                                                         
025900       IF IEL-PENDING                                                     
026000        THEN                                                              
026100         PERFORM 1100-WRITE-AFPKEY;                                       
026200       END-IF;                                                            
026300      WHEN OTHER                                                          
026400       CONTINUE;                                                          
026500     END-EVALUATE;                                                        
026600      SKIP2                                                               
026700     GOBACK.                                                              
026800 TITLE 'FILE I/O ROUTINES'.                                               
026900 1100-WRITE-AFPKEY.                                                       
027000* Add the record to the VSAM key file, incrementing the qualifier         
027100* to guarantee a unique index. If an error occurs, return the             
027200* error code to ACIF to halt processing.                                  
027300     ADD 1 TO INDEX-QUALIFIER.                                            
027400     MOVE INDEX-QUALIFIER TO KEY-KEY-QUALIFIER.                           
027500     MOVE KEY-PTR TO KEY-KEY-LENGTH.                                      
027600     ADD KEY-IEL-LENGTH, KEY-HDR-LENGTH TO                                
027700                         KEY-TLE-LENGTH GIVING AFPKEY-LENGTH.             
027800     WRITE KEY-INDEX-RECORD,                                              
027900       INVALID KEY                                                        
028000        DISPLAY PGMNAME, ' VSAM INDEX INVALID KEY. FILE STATUS ',         
028100                AFPKEY-STATUS, ' VSAM CODES : ',                          
028200                VSAM-RC, VSAM-FCT-CODE, VSAM-FDBK-CODE;                   
028300     END-WRITE.                                                           
028400     IF NOT AFPKEY-OK THEN                                                
028500        DISPLAY PGMNAME, ' ERROR WRITING VSAM OUTPUT ',                   
028600                AFPKEY-STATUS;                                            
028700        MOVE AFPKEY-STATUS-NUM TO RETURN-CODE;                            
028800     END-IF.                                                              
028900     MOVE ZERO TO KEY-TLE-LENGTH, KEY-IEL-LENGTH, KEY-PTR.                
029000     SKIP2                                                                
029100 2000-INIT-INDEX.                                                         
029200* Add a comment to the Begin Index record                                 
029300     MOVE TR-UCOMMENT (2:1) TO COMMENT-TYPE.                              
029400     ADD LENGTH OF COMMENT-ID, 1 GIVING BIN2.                             
029500     MOVE COMMENT-ID TO COMMENT-DATA.                                     
029600     ADD LENGTH OF COMMENT-ID, 1 TO BIN2.                                 
029700     MOVE PGMNAME TO COMMENT-DATA (BIN2 : LENGTH OF PGMNAME).             
029800     ADD LENGTH OF PGMNAME, 1 TO BIN2.                                    
029900     MOVE RUN-DATE TO COMMENT-DATA (BIN2 : LENGTH OF RUN-DATE).           
030000     ADD LENGTH OF RUN-DATE, 1 TO BIN2.                                   
030100     MOVE RUN-TIME TO COMMENT-DATA (BIN2 : LENGTH OF RUN-TIME).           
030200     ADD LENGTH OF RUN-TIME TO BIN2.                                      
030300     ADD LENGTH OF COMMENT-LEN, LENGTH OF COMMENT-TYPE TO BIN2.           
030400     MOVE BIN2-2 TO COMMENT-LEN.                                          
030500     MOVE COMMENT-TRIPLET TO AFPINDEX-DATA                                
030600                             (IDX-RECORDLN + 1 : BIN2).                   
030700     ADD BIN2 TO AFPINDEX-RECLEN.                                         
030800     ADD BIN2 TO IDX-RECORDLN.                                            
030900     SET IDX-USE TO TRUE.                                                 
031000 TITLE 'IEL PROCESSING'.                                                  
031100 3000-PROCESS-IEL.                                                        
031200* Each IEL designates either the start of a group (BNG/ENG) or            
031300* the beginning of a page (BPG).                                          
031400     MOVE 1 TO TRIPLET-PTR.                                               
031500     PERFORM UNTIL TRIPLET-PTR >=                                         
031600                   (IDX-RECORDLN - LENGTH                                 
031700                    OF AFPINDEX-INTRODUCER);                              
031800* the triplet length is the first byte of the triplet                     
031900       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;                    
032000       MOVE BIN2 TO TRIPLET-LENGTH;                                       
032100* the triplet type is the second byte of the triplet                      
032200       EVALUATE (AFPINDEX-DATA (TRIPLET-PTR + 1 : 1))                     
032300*     Structured field offset (relative to zero)                          
032400        WHEN TR-SFOF ( 2 : 1)                                             
032500         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;              
032600         MOVE BIN-4 TO KEY-REC-OFFSET;                                    
032700*     Structured field extent (number of records in object)               
032800        WHEN TR-SFEX ( 2 : 1)                                             
032900         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;              
033000         MOVE BIN-4 TO KEY-REC-EXTENT;                                    
033100*     Byte extent (number of bytes in object)                             
033200        WHEN TR-BYTEX ( 2 : 1)                                            
033300         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;              
033400         MOVE BIN-4 TO KEY-BYTE-EXTENT;                                   
033500*     Byte offset (relative to zero)                                      
033600        WHEN TR-BYTEOF ( 2 : 1)                                           
033700         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;              
033800         MOVE BIN-4 TO KEY-BYTE-OFFSET;                                   
033900*     Medium map page number (pages since last IMM)                       
034000        WHEN TR-PGMAP  ( 2 : 1)                                           
034100         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;              
034200         MOVE BIN-4 TO KEY-MAP-PAGE;                                      
034300*     Fully Qualified Name (page or page group name)                      
034400        WHEN TR-FQN ( 2 : 1)                                              
034500*     The FQN type is the third byte of the triplet                       
034600         EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 2 : 1)                     
034700          WHEN FQN-PGRP                                                   
034800           MOVE PAGE-GROUP TO KEY-KEY-TYPE;                               
034900          WHEN FQN-BPG                                                    
035000           MOVE PAGE-PAGE TO KEY-KEY-TYPE;                                
035100           ADD 1 TO IEL-PAGE-COUNT;                                       
035200         END-EVALUATE;                                                    
035300* FQN contents are always saved in the IEL triplets                       
035400         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO                       
035500              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :                      
035600                                TRIPLET-LENGTH);                          
035700         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                            
035800        WHEN OTHER                                                        
035900* Move all other triplets to index record                                 
036000         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO                       
036100              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :                      
036200                                TRIPLET-LENGTH);                          
036300         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                            
036400       END-EVALUATE;                                                      
036500       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                                 
036600     END-PERFORM.                                                         
036700 TITLE 'TLE PROCESSING'.                                                  
036800 4000-PROCESS-TLE.                                                        
036900* Decode TLE triplets.                                                    
037000* The attribute value (the key fields for the KSDS) is moved to           
037100* the VSAM key. The remaining triplets are saved in the record,           
037200* including the attribute name (key name).                                
037300     MOVE 1 TO TRIPLET-PTR.                                               
037400     PERFORM UNTIL TRIPLET-PTR >=                                         
037500                   (IDX-RECORDLN -                                        
037600                    LENGTH OF AFPINDEX-INTRODUCER);                       
037700* the triplet length is the first byte of the triplet                     
037800       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;                    
037900       MOVE BIN2 TO TRIPLET-LENGTH;                                       
038000* the triplet type is the second byte of the triplet                      
038100       EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 1 : 1)                       
038200*     Attribute value (value of the key)                                  
038300        WHEN TR-ATVAL ( 2 : 1)                                            
038400         COMPUTE KEY-LEFT = KEY-MAX - KEY-PTR;                            
038500         IF KEY-LEFT > (TRIPLET-LENGTH - ATTVAL-OFFSET)                   
038600          THEN                                                            
038700* move attribute value to right end of key                                
038800           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :              
038900                               TRIPLET-LENGTH - ATTVAL-OFFSET)            
039000                TO KEY-KEY-VALUES (KEY-PTR + 1 :                          
039100                   TRIPLET-LENGTH - ATTVAL-OFFSET);                       
039200           COMPUTE KEY-PTR = KEY-PTR + TRIPLET-LENGTH -                   
039300                             ATTVAL-OFFSET;                               
039400         ELSE                                                             
039500* move as much of attribute value to key as will fit                      
039600           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :              
039700                               KEY-LEFT) TO                               
039800                KEY-KEY-VALUES (KEY-PTR + 1 : KEY-LEFT);                  
039900           MOVE KEY-MAX TO KEY-PTR;                                       
040000         END-IF;                                                          
040100        WHEN OTHER                                                        
040200* Move all other triplets to index record                                 
040300         MOVE AFPINDEX-DATA (TRIPLET-PTR : TRIPLET-LENGTH) TO             
040400            KEY-TLE-TRIPLETS (KEY-TLE-LENGTH + 1 : TRIPLET-LENGTH);       
040500         ADD TRIPLET-LENGTH TO KEY-TLE-LENGTH;                            
040600       END-EVALUATE;                                                      
040700       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                                 
040800     END-PERFORM.                                                         
