000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT           
000200* LAST UPDATE ON 14 Aug 1995 AT 08:29:28 BY  VEND789 VERSION 01   *       
000300 ID DIVISION.                                                             
000400 PROGRAM-ID. ACIFRETR.                                                    
000500 AUTHOR. B. E. HAAN, IBM                                                  
000600         H. Turetzky, HYDRA                                               
000700                                                                          
000800     This program reads a file of control statments which select          
000900     pages indexed by ACIF using the ACIFOTX and ACIFIDX exits.           
001000                                                                          
001100     The index is a VSAM file created by ACIFOTX from a MO:DCA            
001200     index object. The index points to records in a VSAM RRDS             
001300     file which contains a MO:DCA datastream that corresponds to          
001400     the MO:DCA index. The control statements contain a key (or           
001500     generic key or a key range) that select from the index the           
001600     pages to be extracted from the RRDS file. The keys                   
001700     correspond to TLE attribute values from the original MO:DCA          
001800     index.                                                               
001900                                                                          
002000     The extracted pages are treated as a single document. A              
002100     MO:DCA Begin Document record is copied from the referenced           
002200     document, followed by the selected groups of pages and then          
002300     by an End Document record.                                           
002400                                                                          
002500     Possible Enhancements                                                
002600                                                                          
002700     A new MO:DCA index file could be created, containing group           
002800     indexes (IELs and TLEs) for the pages as well as page-level          
002900     indexes (IELs).                                                      
003000                                                                          
003100     Other enhancements include extracting documents from more            
003200     than one index/page set, and merging the associated resource         
003300     files. An example of inserting text (such as bar code and            
003400     mailer marking information) may also be provided.                    
003500     The control cards could be changed to use INDEXn= keywords.          
003600                                                             SKIP3        
003700 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                            
003800 DATE-WRITTEN. JUN 93.                                                    
003900 DATE-COMPILED.                                                           
004000 SECURITY. IBM SAMPLE CODE ONLY.                                          
004100*/**************************************************************/         
004200*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */         
004300*/*                                                            */         
004400*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */         
004500*/*                                                            */         
004600*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */         
004700*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */         
004800*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */         
004900*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */         
005000*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */         
005100*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */         
005200*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */         
005300*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */         
005400*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */         
005500*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */         
005600*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */         
005700*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */         
005800*/**************************************************************/         
005900 TITLE 'AFP Page Extractor'.                                              
006000 ENVIRONMENT DIVISION.                                                    
006100 CONFIGURATION SECTION.                                                   
006200 SOURCE-COMPUTER. IBM-370.                                                
006300 OBJECT-COMPUTER. IBM-370.                                                
006400 INPUT-OUTPUT SECTION.                                                    
006500 FILE-CONTROL.                                                            
006600     SELECT AFPCNTRL-FILE        ASSIGN TO AFPCNTRL,                      
006700                                 FILE STATUS AFPCNTRL-STATUS.             
006800     SELECT ACIFRETR-FILE        ASSIGN TO ACIFRETR,                      
006900                                 FILE STATUS ACIFRETR-STATUS.             
007000     SELECT ACIFOTX-FILE         ASSIGN TO ACIFOTX,                       
007100                                 FILE STATUS ACIFOTX-STATUS.              
007200     SELECT AFPPAGIN-FILE        ASSIGN TO AFPPAGIN,                      
007300                                 ORGANIZATION RELATIVE,                   
007400                                 ACCESS MODE DYNAMIC,                     
007500                                 FILE STATUS AFPPAGIN-STATUS              
007600                                             VSAM-STATUS,                 
007700                                 RELATIVE KEY AFPPAGIN-REC.               
007800     SELECT AFPKEY-FILE          ASSIGN TO AFPKEY,                        
007900                                 ORGANIZATION INDEXED,                    
008000                                 ACCESS MODE DYNAMIC,                     
008100                                 FILE STATUS AFPKEY-STATUS                
008200                                             VSAM-STATUS,                 
008300                                 RECORD KEY KEY-KEY.                      
008400                                                             SKIP2        
008500 DATA DIVISION.                                                           
008600 FILE SECTION.                                                            
008700 FD  AFPCNTRL-FILE,                                                       
008800     BLOCK CONTAINS 0 RECORDS,                                            
008900     LABEL RECORDS STANDARD,                                              
009000     RECORDING MODE F.                                                    
009100 01  AFPCNTRL-RECORD.                                                     
009200     05  AFPCNTRL-KEY        PIC X(80).                                   
009300                                                             EJECT        
009400 FD  ACIFRETR-FILE,                                                       
009500     BLOCK CONTAINS 0 RECORDS,                                            
009600     LABEL RECORDS STANDARD,                                              
009700     RECORD VARYING 9  TO 32752 DEPENDING ON ACIFRETR-LENGTH,             
009800     RECORDING MODE V.                                                    
009900 01  ACIFRETR-RECORD.                                                     
010000     05  ACIFRETR-INTRODUCER.                                             
010100       10  ACIFRETR-CC       PIC X.                                       
010200       10  ACIFRETR-LEN-CHR  PIC XX.                                      
010300       10  ACIFRETR-RECLEN   REDEFINES ACIFRETR-LEN-CHR                   
010400                             PIC 9(4) BINARY.                             
010500* NOTE:  9(4) BINARY is used to get halfword integer, but COBOL           
010600* may restrict value to 9999. COBOL II compile-time parm                  
010700* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword             
010800* with no truncation (TRUNC(OPT) produces far better code).               
010900       10  ACIFRETR-TYPE     PIC XXX.                                     
011000       10  ACIFRETR-FLAG     PIC X.                                       
011100       10  ACIFRETR-SEQ-CHR  PIC XX.                                      
011200       10  ACIFRETR-SEQNUM   REDEFINES ACIFRETR-SEQ-CHR                   
011300                             PIC 9(4) BINARY.                             
011400     05  ACIFRETR-DATA.                                                   
011500         10  ACIFRETR-ARRAY      OCCURS 0 TO 32743,                       
011600                                 DEPENDING ON ACIFRETR-RECLEN,            
011700                                 INDEXED BY ACIFRETR-INDX,                
011800                                 PIC X.                                   
011900                                                             EJECT        
012000 FD  ACIFOTX-FILE,                                                        
012100     BLOCK CONTAINS 0 RECORDS,                                            
012200     RECORD VARYING 10 TO 32752 DEPENDING ON ACIFOTX-LENGTH,              
012300     RECORDING MODE V.                                                    
012400 01  ACIFOTX-RECORD.                                                      
012500     05  ACIFOTX-INTRODUCER.                                              
012600       10  ACIFOTX-CC        PIC X.                                       
012700       10  ACIFOTX-LEN-CHR   PIC XX.                                      
012800       10  ACIFOTX-RECLEN    REDEFINES ACIFOTX-LEN-CHR                    
012900                             PIC 9(4) BINARY.                             
013000       10  ACIFOTX-TYPE      PIC XXX.                                     
013100       10  ACIFOTX-FLAG      PIC X.                                       
013200       10  ACIFOTX-SEQ-CHR   PIC XX.                                      
013300       10  ACIFOTX-SEQNUM    REDEFINES ACIFOTX-SEQ-CHR                    
013400                             PIC 9(4) BINARY.                             
013500     05  ACIFOTX-DATA.                                                    
013600         10  ACIFOTX-ARRAY       OCCURS 32743,                            
013700                                 DEPENDING ON ACIFOTX-RECLEN,             
013800                                 INDEXED BY ACIFOTX-INDX,                 
013900                                 PIC X.                                   
014000                                                             EJECT        
014100 FD  AFPPAGIN-FILE,                                                       
014200     RECORD VARYING DEPENDING ON AFPPAGIN-LENGTH.                         
014300     COPY AFPAGOT                                                         
014400          REPLACING ==:PREFIX:== BY ==AFPPAGIN==.                         
014500                                                             EJECT        
014600 FD  AFPKEY-FILE                 GLOBAL,                                  
014700     RECORD VARYING DEPENDING ON AFPKEY-LENGTH.                           
014800     COPY AFPKEY.                                                         
014900                                                             EJECT        
015000 WORKING-STORAGE SECTION.                                                 
015100 77  PGMNAME                 PIC X(8) VALUE 'ACIFRETR'.                   
015200 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.                   
015300 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.                    
015400 77  SF-CC                   PIC X    VALUE X'5A'.                        
015500 77  TYPE-GROUP              PIC X    VALUE X'C7'.                        
015600 77  TYPE-PAGE               PIC X    VALUE X'D7'.                        
015700 77  STATUS-OK               PIC 99   VALUE 0.                            
015800 77  STATUS-EOF              PIC 99   VALUE 10.                           
015900 77  AFPCNTRL-STATUS         PIC 99.                                      
016000 77  ACIFRETR-STATUS         PIC 99.                                      
016100 77  ACIFOTX-STATUS          PIC 99.                                      
016200 77  AFPPAGIN-STATUS         PIC 99.                                      
016300 77  AFPPAGIN-REC            PIC 9(8) BINARY.                             
016400 77  AFPKEY-STATUS           PIC 99.                                      
016500 77  AFPKEY-LENGTH           PIC 9(8) BINARY VALUE 8205.                  
016600 77  INDEX-QUALIFIER         PIC 9(8) BINARY VALUE ZERO.                  
016700 77  PAGE-GROUP              PIC X    VALUE 'G'.                          
016800 77  PAGE-PAGE               PIC X    VALUE 'P'.                          
016900 77  KEY-LEFT                PIC 9(4) BINARY.                             
017000 77  KEY-MAX                 PIC 9(4) BINARY VALUE 255.                   
017100 77  KEY-PTR                 PIC 9(4) BINARY.                             
017200 77  I                       PIC 9(4) BINARY.                             
017300 77  J                       PIC 9(4) BINARY.                             
017400 77  IEL-PENDING-FLAG        PIC X    VALUE LOW-VALUE.                    
017500     88  IEL-PENDING         VALUE HIGH-VALUE.                            
017600 77  AFPPAGIN-EOF-FLAG       PIC X    VALUE LOW-VALUE.                    
017700     88  AFPPAGIN-EOF        VALUE HIGH-VALUE.                            
017800 77  AFPPAGIN-ERROR-FLAG     PIC X    VALUE LOW-VALUE.                    
017900     88  AFPPAGIN-ERROR      VALUE HIGH-VALUE.                            
018000 77  ACIFRETR-ERROR-FLAG     PIC X    VALUE LOW-VALUE.                    
018100     88  ACIFRETR-ERROR      VALUE HIGH-VALUE.                            
018200 77  ACIFOTX-ERROR-FLAG      PIC X    VALUE LOW-VALUE.                    
018300     88  ACIFOTX-ERROR       VALUE HIGH-VALUE.                            
018400 77  AFPCNTRL-EOF-FLAG       PIC X    VALUE LOW-VALUE.                    
018500     88  AFPCNTRL-EOF        VALUE HIGH-VALUE.                            
018600 77  FILE-OPEN-FLAG          PIC X    VALUE LOW-VALUE.                    
018700     88  OPEN-ERROR          VALUE HIGH-VALUE.                            
018800 77  FILE-ERROR-FLAG         PIC X    VALUE LOW-VALUE.                    
018900     88  FILE-ERROR          VALUE HIGH-VALUE.                            
019000 77  INDEX-FLAG              PIC X    VALUE LOW-VALUE.                    
019100     88  NO-MORE-INDEX       VALUE HIGH-VALUE.                            
019200                                                             SKIP1        
019300 01  ACIFRETR-LENGTH         PIC 9(8) BINARY.                             
019400 01  AFPPAGIN-LENGTH         PIC 9(8) BINARY.                             
019500 01  ACIFOTX-LENGTH          PIC 9(8) BINARY.                             
019600 01  AFPCNTRL-KEYLEN         PIC 9(8) BINARY.                             
019700 01  NEW-INDEX-COUNTERS.                                                  
019800   05  NEW-BDT-SIZE          PIC 9(8) BINARY VALUE 0.                     
019900   05  NEW-BNG-SIZE          PIC 9(8) BINARY VALUE 0.                     
020000   05  NEW-BPG-SIZE          PIC 9(8) BINARY VALUE 0.                     
020100 01  AFP-BDT                 PIC X(256).                                  
020200                                                             SKIP1        
020300 01  VSAM-STATUS.                                                         
020400     05  VSAM-RC             PIC 9(4) BINARY.                             
020500     05  VSAM-FCT-CODE       PIC 9(1) BINARY.                             
020600     05  VSAM-FDBK-CODE      PIC 9(3) BINARY.                             
020700                                                             SKIP1        
020800 01  DATE-DATA.                                                           
020900   05  RUN-DATE.                                                          
021000     10 RUN-YY                 PIC 99.                                    
021100     10 RUN-MM                 PIC 99.                                    
021200     10 RUN-DD                 PIC 99.                                    
021300   05  COMPILE-DATE.                                                      
021400     10  COMP-DATE             PIC X(8).                                  
021500     10  COMP-TIME             PIC X(12).                                 
021600   05  RUN-TIME.                                                          
021700     10  RUN-HH                PIC 99.                                    
021800     10  RUN-MM                PIC 99.                                    
021900     10  RUN-SS                PIC 99.                                    
022000     10  RUN-MS                PIC 99.                                    
022100                                                             SKIP2        
022200 01  BINARY-NUMBERS.                                                      
022300     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.              
022400     05  BIN4-X                  REDEFINES BIN-4                          
022500                                 PIC X(4).                                
022600     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.              
022700     05  BIN2-X                  REDEFINES BIN2.                          
022800         10  FILLER              PIC X.                                   
022900         10  BIN2-2              PIC X.                                   
023000                                                             SKIP2        
023100 01  PAGE-DATA.                                                           
023200     05  PAGE-REC-STATS.                                                  
023300         10  PAGE-RECORD-OFFSET  PIC 9(8) BINARY.                         
023400         10  PAGE-RECORD-EXTENT  PIC 9(8) BINARY.                         
023500         10  PAGE-BYTE-OFFSET    PIC 9(8) BINARY.                         
023600         10  PAGE-BYTE-EXTENT    PIC 9(8) BINARY.                         
023700                                                             SKIP2        
023800 01  TRIPLET-DATA.                                                        
023900     05  TRIPLET-PTR             PIC 9(8) BINARY.                         
024000     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                         
024100* offset to start of attribute value                                      
024200     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.                 
024300*  STRUCTURED FIELD DEFINITIONS'.                                         
024400     COPY STRFLDS SUPPRESS.                                               
024500 TITLE 'INITIALIZATION AND MAIN LINE'.                                    
024600 PROCEDURE DIVISION.                                                      
024700* Method of Operation:                                                    
024800* A control card is read,  and a start issued on the keyed                
024900* file for the requested value. The key file record is then read.         
025000******* IEL's not currently Implemented !!!!! ********************        
025100*  An IEL record is constructed from the key record. The                  
025200* start extents are the next values for the document output file,         
025300* ending extents are the next values plus the ending extents in           
025400* the key record. The IEL is written, followed by TLEs constructed        
025500* from the key record.                                                    
025600******* IEL's not currently Implemented !!!!! ********************        
025700*                                                                         
025800* The document file is then read, using the key start structured          
025900* field number, until the ending number is reached. For each BPG          
026000* in the document, a page IEL is built, and at EPG it is written          
026100* with the appropriate extent values and page names.                      
026200* Document structured fields are written as read.                         
026300*                                                                         
026400* When all pages for the current key record have been written,            
026500* the next key record is read. If it is within the key range              
026600* selected, it is processed as above, otherwise the next control          
026700* card is read.                                                           
026800*                                                                         
026900                                                           EJECT          
027000 000-MAINLINE.                                                            
027100     PERFORM 0900-INITIALIZE.                                             
027200     IF OPEN-ERROR THEN                                                   
027300       GOBACK.                                                            
027400                                                            SKIP1         
027500     PERFORM 1000-READ-AFPCNTRL.                                          
027600                                                            SKIP1         
027700     PERFORM 1100-WRITE-BDT.                                              
027800                                                            SKIP1         
027900     PERFORM UNTIL AFPCNTRL-EOF OR FILE-ERROR;                            
028000       MOVE LOW-VALUES TO INDEX-FLAG;                                     
028100       PERFORM 2000-START-KEY;                                            
028200                                                            SKIP1         
028300       PERFORM UNTIL NO-MORE-INDEX;                                       
028400                                                            SKIP1         
028500         PERFORM 2600-POSITION-RRDS;                                      
028600                                                            SKIP1         
028700         PERFORM 2700-READ-N-WRITE-NEXT-GROUP;                            
028800                                                            SKIP1         
028900*        PERFORM WRITE-NEW-INDEX USING KEY-INDEX-REC;                     
029000         PERFORM 2100-GET-NEXT-GROUP-INDEX;                               
029100                                                            SKIP1         
029200       END-PERFORM;                                                       
029300                                                            SKIP1         
029400       PERFORM 1000-READ-AFPCNTRL;                                        
029500                                                            SKIP1         
029600     END-PERFORM.                                                         
029700                                                            SKIP1         
029800     PERFORM 1110-WRITE-EDT.                                              
029900                                                            SKIP1         
030000     GOBACK.                                                              
030100 TITLE 'INTIAL STARTUP, OPEN FILES ET AL'                                 
030200 0900-INITIALIZE.                                                         
030300     MOVE WHEN-COMPILED TO COMPILE-DATE.                                  
030400     ACCEPT RUN-DATE FROM DATE.                                           
030500     ACCEPT RUN-TIME FROM TIME.                                           
030600     OPEN INPUT  AFPPAGIN-FILE,                                           
030700                 AFPCNTRL-FILE,                                           
030800                 AFPKEY-FILE,                                             
030900          OUTPUT ACIFRETR-FILE,                                           
031000                 ACIFOTX-FILE.                                            
031100     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                          
031200       MOVE HIGH-VALUES TO AFPPAGIN-ERROR-FLAG;                           
031300       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                                
031400       DISPLAY 'ERROR OPENING AFPPAGIN INPUT FILE STATUS: '               
031500       AFPPAGIN-STATUS;                                                   
031600       DISPLAY 'VSAM RC   : ' VSAM-RC;                                    
031700       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                              
031800       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                             
031900       DISPLAY ' ';                                                       
032000       MOVE VSAM-RC TO RETURN-CODE;                                       
032100     ELSE                                                                 
032200* Read the first record so we can save the BDT.                           
032300* Cross-reference FQN's will be wrong, but may be helpful in              
032400* problem tracking.                                                       
032500* This would also allow easier use of orginal index records               
032600       PERFORM 9100-READ-AFPPAGIN-RECORD;                                 
032700       MOVE AFPPAGIN-RECORD TO AFP-BDT;                                   
032800     END-IF.                                                              
032900     IF AFPCNTRL-STATUS NOT EQUAL STATUS-OK THEN                          
033000       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                                
033100       DISPLAY 'ERROR OPENING AFPCNTRL INPUT FILE STATUS: '               
033200       AFPCNTRL-STATUS;                                                   
033300       DISPLAY ' ';                                                       
033400       MOVE AFPCNTRL-STATUS TO RETURN-CODE;                               
033500     END-IF.                                                              
033600     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                            
033700       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                                
033800       DISPLAY 'ERROR OPENING AFPKEY INPUT FILE STATUS: '                 
033900       AFPKEY-STATUS;                                                     
034000       DISPLAY 'VSAM RC   : ' VSAM-RC;                                    
034100       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                              
034200       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                             
034300       DISPLAY ' ';                                                       
034400       MOVE AFPKEY-STATUS TO RETURN-CODE;                                 
034500     END-IF.                                                              
034600     IF ACIFRETR-STATUS NOT EQUAL STATUS-OK THEN                          
034700       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                                
034800       DISPLAY 'ERROR OPENING ACIFRETR OUTPUT FILE STATUS: '              
034900       ACIFRETR-STATUS;                                                   
035000       DISPLAY ' ';                                                       
035100       MOVE ACIFRETR-STATUS TO RETURN-CODE;                               
035200     END-IF.                                                              
035300     IF ACIFOTX-STATUS NOT EQUAL STATUS-OK THEN                           
035400       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                                
035500       DISPLAY 'ERROR OPENING ACIFOTX OUTPUT FILE STATUS: '               
035600       ACIFOTX-STATUS;                                                    
035700       MOVE ACIFOTX-STATUS TO RETURN-CODE;                                
035800       DISPLAY ' ';                                                       
035900     END-IF.                                                              
036000* initialize table for finding end of string                              
036100                                                          SKIP1           
036200 TITLE 'FILE I/O ROUTINES'.                                               
036300 1000-READ-AFPCNTRL.                                                      
036400     READ AFPCNTRL-FILE,                                                  
036500       END-READ;                                                          
036600     IF AFPCNTRL-STATUS NOT EQUAL STATUS-OK THEN                          
036700       MOVE HIGH-VALUES TO AFPCNTRL-EOF-FLAG;                             
036800       IF AFPCNTRL-STATUS NOT EQUAL STATUS-EOF THEN                       
036900         DISPLAY 'ERROR READING AFPCNTRL FILE - STATUS: '                 
037000                 AFPCNTRL-STATUS;                                         
037100         MOVE AFPCNTRL-STATUS TO RETURN-CODE;                             
037200       END-IF;                                                            
037300     ELSE                                                                 
037400       MOVE LOW-VALUES   TO KEY-KEY;                                      
037500       MOVE AFPCNTRL-KEY TO KEY-KEY-VALUES(1:LENGTH AFPCNTRL-KEY);        
037600       MOVE TYPE-GROUP   TO KEY-KEY-TYPE;                                 
037700                                                          SKIP1           
037800       PERFORM VARYING AFPCNTRL-KEYLEN FROM LENGTH AFPCNTRL-RECORD        
037900         BY -1 UNTIL                                                      
038000         AFPCNTRL-RECORD(AFPCNTRL-KEYLEN:1) NOT EQUAL SPACE;              
038100       END-PERFORM;                                                       
038200     END-IF.                                                              
038300 TITLE 'WRITE BDT AND EDTS FOR NEW DOCUMENT'                              
038400 1100-WRITE-BDT.                                                          
038500*SHOULD USE ORIGINAL BDT TO PRESERVE LENGTHS IN INDICES                   
038600     MOVE AFP-BDT TO AFPPAGIN-RECORD.                                     
038700*SHOULD USE ORIGINAL BDT TO PRESERVE LENGTHS IN INDICES                   
038800     ADD 1 AFPPAGIN-RECLEN GIVING AFPPAGIN-LENGTH.                        
038900     PERFORM 9000-WRITE-ACIFRETR-REC.                                     
039000                                                          SKIP1           
039100 1110-WRITE-EDT.                                                          
039200     MOVE LOW-VALUES  TO ACIFRETR-RECORD.                                 
039300     MOVE SF-EDT      TO AFPPAGIN-TYPE.                                   
039400     MOVE SF-CC       TO AFPPAGIN-CC.                                     
039500     MOVE HIGH-VALUES TO AFPPAGIN-DATA(1:8).                              
039600     MOVE 16          TO AFPPAGIN-RECLEN.                                 
039700     ADD 1 AFPPAGIN-RECLEN GIVING AFPPAGIN-LENGTH.                        
039800     PERFORM 9000-WRITE-ACIFRETR-REC.                                     
039900                                                         SKIP1            
040000 TITLE 'START AND READ THE REQUESTED INDEX FILE RECORDS'                  
040100 2000-START-KEY.                                                          
040200     START AFPKEY-FILE KEY GREATER OR EQUAL KEY-KEY-VALUES,               
040300     END-START.                                                           
040400     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                            
040500*      MOVE HIGH-VALUES TO AFPKEY-ERROR-FLAG,                             
040600       DISPLAY 'ERROR STARTING AFPKEY FILE - STATUS: '                    
040700                 AFPKEY-STATUS;                                           
040800       DISPLAY 'VSAM RC   : ' VSAM-RC;                                    
040900       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                              
041000       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                             
041100       DISPLAY ' ';                                                       
041200       MOVE AFPKEY-STATUS TO RETURN-CODE;                                 
041300     END-IF.                                                              
041400*      INVALID KEY                                                        
041500*        MOVE HIGH-VALUE TO NO-MORE-INDEX;                                
041600*      NOT INVALID KEY                                                    
041700*        MOVE LOW-VALUE TO NO-MORE-INDEX;                                 
041800                                                         SKIP1            
041900     PERFORM 2100-GET-NEXT-GROUP-INDEX.                                   
042000                                                         SKIP1            
042100 2100-GET-NEXT-GROUP-INDEX.                                               
042200                                                         SKIP1            
042300     PERFORM 9200-GET-NEXT-INDEX                                          
042400         WITH TEST AFTER                                                  
042500         UNTIL KEY-KEY-TYPE EQUAL TYPE-GROUP.                             
042600                                                         SKIP1            
042700     IF AFPCNTRL-KEY(1:AFPCNTRL-KEYLEN) NOT EQUAL                         
042800        KEY-KEY-VALUES(1:AFPCNTRL-KEYLEN) THEN                            
042900       MOVE HIGH-VALUES TO INDEX-FLAG;                                    
043000      ELSE                                                                
043100       DISPLAY PGMNAME ' INDEX ENTRY '                                    
043200               KEY-KEY-VALUES (1:KEY-KEY-LENGTH);                         
043300       DISPLAY PGMNAME ' FOUND FOR '                                      
043400               AFPCNTRL-KEY (1:AFPCNTRL-KEYLEN);                          
043500     END-IF.                                                              
043600                                                         SKIP1            
043700 2600-POSITION-RRDS.                                                      
043800     MOVE LOW-VALUES TO AFPPAGIN-RECORD.                                  
043900* Structured offsets in index are zero-based, RRDS is 1-based.            
044000     ADD      1 TO   KEY-REC-OFFSET GIVING AFPPAGIN-REC.                  
044100     START AFPPAGIN-FILE;                                                 
044200     END-START.                                                           
044300     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                          
044400       MOVE HIGH-VALUES TO AFPPAGIN-ERROR-FLAG,                           
044500       DISPLAY 'ERROR STARTING AFPPAGIN FILE - STATUS: '                  
044600                 AFPPAGIN-STATUS;                                         
044700       DISPLAY 'VSAM RC   : ' VSAM-RC;                                    
044800       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                              
044900       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                             
045000       DISPLAY ' ';                                                       
045100       MOVE AFPPAGIN-STATUS TO RETURN-CODE;                               
045200     END-IF.                                                              
045300 TITLE 'INDEX FILE READ AND WRITE'.                                       
045400 2700-READ-N-WRITE-NEXT-GROUP.                                            
045500     PERFORM UNTIL AFPPAGIN-TYPE = SF-ENG;                                
045600       PERFORM 9100-READ-AFPPAGIN-RECORD;                                 
045700       PERFORM 9000-WRITE-ACIFRETR-REC;                                   
045800     END-PERFORM.                                                         
045900 TITLE 'WRITE AFP EXTRACTED RECORDS'                                      
046000 9000-WRITE-ACIFRETR-REC.                                                 
046100     MOVE AFPPAGIN-LENGTH TO ACIFRETR-LENGTH.                             
046200     WRITE ACIFRETR-RECORD FROM AFPPAGIN-RECORD.                          
046300     IF ACIFRETR-STATUS NOT EQUAL STATUS-OK THEN                          
046400       MOVE HIGH-VALUES TO FILE-ERROR-FLAG;                               
046500       DISPLAY 'ERROR WRITING ACIFRETR FILE - STATUS: '                   
046600                 ACIFRETR-STATUS;                                         
046700       DISPLAY 'TRYING TO WRITE RECORD OF LENGTH '                        
046800       ACIFRETR-LENGTH;                                                   
046900       DISPLAY ' ';                                                       
047000       MOVE ACIFRETR-STATUS TO RETURN-CODE;                               
047100     ELSE                                                                 
047200       ADD ACIFRETR-LENGTH TO NEW-BDT-SIZE;                               
047300     END-IF.                                                              
047400 TITLE 'READ AFP EXTRACTED RECORDS'                                       
047500 9100-READ-AFPPAGIN-RECORD.                                               
047600     READ AFPPAGIN-FILE NEXT RECORD.                                      
047700     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                          
047800       MOVE HIGH-VALUES TO AFPPAGIN-EOF-FLAG;                             
047900       IF AFPPAGIN-STATUS NOT EQUAL STATUS-EOF THEN                       
048000         MOVE HIGH-VALUES TO FILE-ERROR-FLAG;                             
048100         DISPLAY 'ERROR READING AFPPAGIN FILE - STATUS: ';                
048200                 AFPPAGIN-STATUS;                                         
048300         DISPLAY 'VSAM RC   : ' VSAM-RC;                                  
048400         DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                            
048500         DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                           
048600         DISPLAY ' ';                                                     
048700         MOVE AFPPAGIN-STATUS TO RETURN-CODE;                             
048800       END-IF;                                                            
048900     END-IF.                                                              
049000 TITLE 'START AND READ THE REQUESTED INDEX FILE RECORD'                   
049100 9200-GET-NEXT-INDEX.                                                     
049200     READ AFPKEY-FILE NEXT RECORD.                                        
049300     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                            
049400*      MOVE HIGH-VALUES TO AFPKEY-ERROR-FLAG,                             
049500       DISPLAY 'ERROR READING AFPKEY FILE - STATUS: '                     
049600                 AFPKEY-STATUS;                                           
049700       DISPLAY 'VSAM RC   : ' VSAM-RC;                                    
049800       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                              
049900       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                             
050000       DISPLAY ' ';                                                       
050100       MOVE AFPKEY-STATUS TO RETURN-CODE;                                 
050200     END-IF.                                                              
050300*      AT END MOVE HIGH-VALUE TO AFPKEY-EOF.                              
050400* At each begin page a new IEL for the page is begun with the             
050500* starting record number and byte offset of the BPG. At each              
050600* end page, the extent values are filled in and the IEL written.          
