000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   AFPINDEX
000200 ID DIVISION.                                                     AFPINDEX
000300* LAST UPDATE ON 4 Aug 1994 AT 10:49:42 BY  VEND789 VERSION 01   *AFPINDEX
000400 PROGRAM-ID. AFPINDEX.                                            AFPINDEX
000500 AUTHOR. B. E. HAAN, Pennant Systems, IBM                         AFPINDEX
000600         H. Turetzky, HYDRA                                       AFPINDEX
000700     This program creates a VSAM index (KSDS) from a MO:DCA       AFPINDEX
000800     document index.                                              AFPINDEX
000900                                                                  AFPINDEX
001000     There are several ways to organize such an index. This       AFPINDEX
001100     program assumes TLE records occur in heirarchical order,     AFPINDEX
001200     ie., most signficant first. One index record will be         AFPINDEX
001300     created for each page (it is assumed that the input index is AFPINDEX
001400     at page level). We further assume that the index is of       AFPINDEX
001500     the style created by ACIF (5648-062).                        AFPINDEX
001600                                                                  AFPINDEX
001700     The values for all of the TLE attribute value triplets are   AFPINDEX
001800     placed in the VSAM key, suffixed by a flag indicating if     AFPINDEX
001900     the index is for a group or page, and a counter to           AFPINDEX
002000     guarantee uniqueness.  Since VSAM limits key length to 255,  AFPINDEX
002100     and the value for any attribute value triplet can be 250     AFPINDEX
002200     bytes, this scheme is will not handle all possible MO:DCA    AFPINDEX
002300     indexes. However, for most purposes this length is adequate  AFPINDEX
002400     to hold all the values being indexed.                        AFPINDEX
002500                                                                  AFPINDEX
002600     The data portion of the VSAM index record contains all of    AFPINDEX
002700     the locating information (byte and record offsets) and other AFPINDEX
002800     information contained on the page and group IELs, so that    AFPINDEX
002900     the MO:DCA index can be reconstructed from the VSAM file.    AFPINDEX
003000                                                                  AFPINDEX
003100     All of the TLE triplets are saved in the data portion of     AFPINDEX
003200     the index record.                                            AFPINDEX
003300                                                                  AFPINDEX
003400     For cases where this organization is inadequate, such as     AFPINDEX
003500     TLEs containing long values, the necessity to search on      AFPINDEX
003600     secondary index values, or a different structure in the      AFPINDEX
003700     relationship of tag/value pairs, the index could be          AFPINDEX
003800     organized as a primary index using the group name, and       AFPINDEX
003900     VSAM alternate indexes for each tag. A more flexible         AFPINDEX
004000     method would be DB2 tables, where unique relationships       AFPINDEX
004100     can be defined between keys.                                 AFPINDEX
004200     EJECT                                                        AFPINDEX
004300 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    AFPINDEX
004400 DATE-WRITTEN. JUN 93.                                            AFPINDEX
004500 DATE-COMPILED.                                                   AFPINDEX
004600 SECURITY. IBM SAMPLE CODE ONLY.                                  AFPINDEX
004700*/**************************************************************/ AFPINDEX
004800*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */ AFPINDEX
004900*/*                                                            */ AFPINDEX
005000*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ AFPINDEX
005100*/*                                                            */ AFPINDEX
005200*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ AFPINDEX
005300*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ AFPINDEX
005400*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ AFPINDEX
005500*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ AFPINDEX
005600*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ AFPINDEX
005700*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ AFPINDEX
005800*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ AFPINDEX
005900*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ AFPINDEX
006000*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ AFPINDEX
006100*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ AFPINDEX
006200*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ AFPINDEX
006300*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ AFPINDEX
006400*/**************************************************************/ AFPINDEX
006500 TITLE 'AFP INDEX PROCESSOR'.                                     AFPINDEX
006600 ENVIRONMENT DIVISION.                                            AFPINDEX
006700 CONFIGURATION SECTION.                                           AFPINDEX
006800 SOURCE-COMPUTER. IBM-370.                                        AFPINDEX
006900 OBJECT-COMPUTER. IBM-370.                                        AFPINDEX
007000 INPUT-OUTPUT SECTION.                                            AFPINDEX
007100 FILE-CONTROL.                                                    AFPINDEX
007200     SELECT AFPINDEX-FILE        ASSIGN TO ACIFINDX,              AFPINDEX
007300                                 FILE STATUS AFPQSAM-STATUS.      AFPINDEX
007400     SELECT AFPKEY-FILE          ASSIGN TO AFPKEY,                AFPINDEX
007500                                 ORGANIZATION INDEXED,            AFPINDEX
007600                                 ACCESS MODE DYNAMIC,             AFPINDEX
007700                                 FILE STATUS AFPKEY-STATUS        AFPINDEX
007800                                             VSAM-STATUS,         AFPINDEX
007900                                 RECORD KEY KEY-KEY.              AFPINDEX
008000   EJECT                                                          AFPINDEX
008100 DATA DIVISION.                                                   AFPINDEX
008200 FILE SECTION.                                                    AFPINDEX
008300 FD  AFPINDEX-FILE,                                               AFPINDEX
008400     BLOCK CONTAINS 0 RECORDS,                                    AFPINDEX
008500     RECORDING MODE IS V                                          AFPINDEX
008600     RECORD VARYING FROM 10 TO 32752 DEPENDING ON AFPINDEX-LENGTH.AFPINDEX
008700                                                                  AFPINDEX
008800 01  AFPINDEX-RECORD.                                             AFPINDEX
008900     05  AFPINDEX-INTRODUCER.                                     AFPINDEX
009000       10  AFPINDEX-CC       PIC X.                               AFPINDEX
009100       10  AFPINDEX-LEN-CHR  PIC XX.                              AFPINDEX
009200       10  AFPINDEX-RECLEN   REDEFINES AFPINDEX-LEN-CHR           AFPINDEX
009300                             PIC 9(4) COMP.                       AFPINDEX
009400* NOTE:  9(4) COMP is used to get halfword integer, but COBOL     AFPINDEX
009500* may restrict value to 9999. COBOL II compile-time parm          AFPINDEX
009600* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword     AFPINDEX
009700* with no truncation (TRUNC(OPT) produces far better code).       AFPINDEX
009800       10  AFPINDEX-TYPE     PIC XXX.                             AFPINDEX
009900       10  AFPINDEX-FLAG     PIC X.                               AFPINDEX
010000       10  AFPINDEX-SEQ-CHR  PIC XX.                              AFPINDEX
010100       10  AFPINDEX-SEQNUM   REDEFINES AFPINDEX-SEQ-CHR           AFPINDEX
010200                             PIC 9(4) COMP.                       AFPINDEX
010300     05  AFPINDEX-DATA.                                           AFPINDEX
010400         10  AFPINDEX-ARRAY      OCCURS 32743,                    AFPINDEX
010500                                 DEPENDING ON AFPINDEX-RECLEN,    AFPINDEX
010600                                 INDEXED BY AFPINDEX-INDX,        AFPINDEX
010700                                 PIC X.                           AFPINDEX
010800   EJECT                                                          AFPINDEX
010900 FD  AFPKEY-FILE                 GLOBAL,                          AFPINDEX
011000     RECORD VARYING DEPENDING ON AFPKEY-LENGTH.                   AFPINDEX
011100     COPY AFPKEY.                                                 AFPINDEX
011200   EJECT                                                          AFPINDEX
011300 WORKING-STORAGE SECTION.                                         AFPINDEX
011400 77  PGMNAME                 PIC X(8) VALUE 'AFPINDEX'.           AFPINDEX
011500 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           AFPINDEX
011600 77  ABEND-CODE              PIC 9(4) COMP VALUE 12.              AFPINDEX
011700 77  SF-CC                   PIC X    VALUE X'5A'.                AFPINDEX
011800 77  AFPKEY-LENGTH           PIC 9(8) COMP VALUE 8205.            AFPINDEX
011900 77  AFPKEY-STATUS           PIC 99.                              AFPINDEX
012000     88  AFPKEY-OK           VALUE 00.                            AFPINDEX
012100 77  AFPQSAM-STATUS          PIC 99   VALUE ZERO.                 AFPINDEX
012200     88  AFPQSAM-OK          VALUE 00.                            AFPINDEX
012300     88  AFPQSAM-EOF         VALUE 47.                            AFPINDEX
012400 77  INDEX-QUALIFIER         PIC 9(8) COMP VALUE ZERO.            AFPINDEX
012500 77  PAGE-GROUP              PIC X    VALUE 'G'.                  AFPINDEX
012600 77  PAGE-PAGE               PIC X    VALUE 'P'.                  AFPINDEX
012700 77  KEY-LEFT                PIC 9(4) BINARY.                     AFPINDEX
012800 77  KEY-MAX                 PIC 9(4) BINARY VALUE 255.           AFPINDEX
012900 77  KEY-HDR-LENGTH          PIC 9(4) BINARY.                     AFPINDEX
013000 77  KEY-PTR                 PIC 9(4) BINARY.                     AFPINDEX
013100 77  IEL-PENDING-FLAG        PIC X    VALUE LOW-VALUE.            AFPINDEX
013200     88  IEL-PENDING         VALUE HIGH-VALUE.                    AFPINDEX
013300 77  AFPINDEX-EOF-FLAG       PIC X    VALUE LOW-VALUE.            AFPINDEX
013400     88  AFPINDEX-EOF        VALUE HIGH-VALUE.                    AFPINDEX
013500     SKIP1                                                        AFPINDEX
013600 01  AFPINDEX-LENGTH         PIC 9(8) COMP.                       AFPINDEX
013700     SKIP1                                                        AFPINDEX
013800 01  VSAM-STATUS.                                                 AFPINDEX
013900     05  VSAM-RC                 PIC 9(4) COMP.                   AFPINDEX
014000     05  VSAM-FCT-CODE           PIC 9(1) COMP.                   AFPINDEX
014100     05  VSAM-FDBK-CODE          PIC 9(3) COMP.                   AFPINDEX
014200     SKIP1                                                        AFPINDEX
014300 01  DATE-DATA.                                                   AFPINDEX
014400   05  RUN-DATE.                                                  AFPINDEX
014500     10 RUN-YY                 PIC 99.                            AFPINDEX
014600     10 RUN-MM                 PIC 99.                            AFPINDEX
014700     10 RUN-DD                 PIC 99.                            AFPINDEX
014800   05  COMPILE-DATE.                                              AFPINDEX
014900     10  COMP-DATE             PIC X(8).                          AFPINDEX
015000     10  COMP-TIME             PIC X(12).                         AFPINDEX
015100   05  RUN-TIME.                                                  AFPINDEX
015200     10  RUN-HH                PIC 99.                            AFPINDEX
015300     10  RUN-MM                PIC 99.                            AFPINDEX
015400     10  RUN-SS                PIC 99.                            AFPINDEX
015500     10  RUN-MS                PIC 99.                            AFPINDEX
015600     SKIP2                                                        AFPINDEX
015700 01  BINARY-NUMBERS.                                              AFPINDEX
015800     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.      AFPINDEX
015900     05  BIN4-X                  REDEFINES BIN-4                  AFPINDEX
016000                                 PIC X(4).                        AFPINDEX
016100     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.      AFPINDEX
016200     05  BIN2-X                  REDEFINES BIN2.                  AFPINDEX
016300         10  FILLER              PIC X.                           AFPINDEX
016400         10  BIN2-2              PIC X.                           AFPINDEX
016500     SKIP2                                                        AFPINDEX
016600 01  TRIPLET-DATA.                                                AFPINDEX
016700     05  TRIPLET-PTR             PIC 9(8) BINARY.                 AFPINDEX
016800     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                 AFPINDEX
016900* offset to start of attribute value                              AFPINDEX
017000     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.         AFPINDEX
017100* STRUCTURED FIELD DEFINITIONS                                    AFPINDEX
017200     COPY STRFLDS SUPPRESS.                                       AFPINDEX
017300 TITLE 'INITIALIZATION AND MAIN LINE'.                            AFPINDEX
017400 PROCEDURE DIVISION.                                              AFPINDEX
017500*  This program reads a ACIF created index (AFPINDEX) and         AFPINDEX
017600* creates a similar index (AFPKEY) using a VSAM KSDS.  Each IEL   AFPINDEX
017700* starts a corresponding new VSAM record, subsequent TLE records  AFPINDEX
017800* that reference the IEL are also accumulated.  When the next     AFPINDEX
017900* IEL is encounterd the prior IEL and TLE's are written to a      AFPINDEX
017910* single VSAM record.  .  00-MAINLINE.                            AFPINDEX
018000 0AFPINDEX                                                        AFPINDEX
018100     MOVE WHEN-COMPILED TO COMPILE-DATE.                          AFPINDEX
018200     ACCEPT RUN-DATE FROM DATE.                                   AFPINDEX
018300     ACCEPT RUN-TIME FROM TIME.                                   AFPINDEX
018400        SKIP2                                                     AFPINDEX
018500     OPEN INPUT  AFPINDEX-FILE,                                   AFPINDEX
018600          OUTPUT AFPKEY-FILE.                                     AFPINDEX
018700        SKIP2                                                     AFPINDEX
018800     IF ((NOT AFPQSAM-OK) OR (NOT AFPKEY-OK)) THEN                AFPINDEX
018900        DISPLAY 'AFPQSAM STATUS AFTER OPEN ' AFPQSAM-STATUS;      AFPINDEX
019000        DISPLAY 'AFPKEY  STATUS AFTER OPEN ' AFPKEY-STATUS;       AFPINDEX
019100        DISPLAY ' ';                                              AFPINDEX
019200        IF AFPQSAM-STATUS > AFPKEY-STATUS                         AFPINDEX
019300         THEN                                                     AFPINDEX
019400          MOVE AFPQSAM-STATUS TO RETURN-CODE;                     AFPINDEX
019500         ELSE                                                     AFPINDEX
019600          MOVE AFPKEY-STATUS TO RETURN-CODE;                      AFPINDEX
019700        END-IF;                                                   AFPINDEX
019800        GOBACK.                                                   AFPINDEX
019900        SKIP2                                                     AFPINDEX
020000     ADD LENGTH OF KEY-LOCATION-DATA                              AFPINDEX
020100         LENGTH OF KEY-IEL-LENGTH                                 AFPINDEX
020200         LENGTH OF KEY-TLE-LENGTH                                 AFPINDEX
020300         LENGTH OF KEY-KEY        GIVING                          AFPINDEX
020400         KEY-HDR-LENGTH.                                          AFPINDEX
020500     PERFORM 1000-READ-AFPINDEX.                                  AFPINDEX
020600        SKIP1                                                     AFPINDEX
020700     PERFORM UNTIL AFPINDEX-EOF;                                  AFPINDEX
020800        SKIP2                                                     AFPINDEX
020900       EVALUATE AFPINDEX-TYPE;                                    AFPINDEX
021000        WHEN SF-BDI                                               AFPINDEX
021100         PERFORM 2000-INIT-INDEX;                                 AFPINDEX
021200        WHEN SF-IEL                                               AFPINDEX
021300         IF IEL-PENDING                                           AFPINDEX
021400          THEN                                                    AFPINDEX
021500           PERFORM 1100-WRITE-AFPKEY;                             AFPINDEX
021600         END-IF;                                                  AFPINDEX
021700         PERFORM 3000-PROCESS-IEL;                                AFPINDEX
021800         SET IEL-PENDING TO TRUE;                                 AFPINDEX
021900        WHEN SF-TLE                                               AFPINDEX
022000         PERFORM 4000-PROCESS-TLE;                                AFPINDEX
022100        WHEN SF-EDI                                               AFPINDEX
022200         IF IEL-PENDING                                           AFPINDEX
022300          THEN                                                    AFPINDEX
022400           PERFORM 1100-WRITE-AFPKEY;                             AFPINDEX
022500         END-IF;                                                  AFPINDEX
022600         CLOSE AFPINDEX-FILE,                                     AFPINDEX
022700               AFPKEY-FILE;                                       AFPINDEX
022800        WHEN OTHER                                                AFPINDEX
022900         CONTINUE;                                                AFPINDEX
023000       END-EVALUATE;                                              AFPINDEX
023100        SKIP2                                                     AFPINDEX
023200       PERFORM 1000-READ-AFPINDEX;                                AFPINDEX
023300        SKIP2                                                     AFPINDEX
023400     END-PERFORM.                                                 AFPINDEX
023500     GOBACK.                                                      AFPINDEX
023600 TITLE 'FILE I/O ROUTINES'.                                       AFPINDEX
023700 1000-READ-AFPINDEX.                                              AFPINDEX
023800     READ AFPINDEX-FILE                                           AFPINDEX
023900          AT END DISPLAY 'AT END OF QSAM INPUT'                   AFPINDEX
024000                 MOVE HIGH-VALUES TO AFPINDEX-EOF-FLAG;           AFPINDEX
024100     END-READ;                                                    AFPINDEX
024200     IF AFPQSAM-EOF THEN                                          AFPINDEX
024300       MOVE HIGH-VALUES TO AFPINDEX-EOF-FLAG;                     AFPINDEX
024400     ELSE                                                         AFPINDEX
024500       IF NOT AFPQSAM-OK THEN                                     AFPINDEX
024600          DISPLAY 'ERROR READING QSAM INPUT ' AFPQSAM-STATUS;     AFPINDEX
024700          MOVE HIGH-VALUES TO AFPINDEX-EOF-FLAG;                  AFPINDEX
024800          MOVE AFPQSAM-STATUS TO RETURN-CODE;                     AFPINDEX
024900       END-IF;                                                    AFPINDEX
025000     END-IF.                                                      AFPINDEX
025100     SKIP2                                                        AFPINDEX
025200 1100-WRITE-AFPKEY.                                               AFPINDEX
025300     ADD 1 TO INDEX-QUALIFIER.                                    AFPINDEX
025400     MOVE INDEX-QUALIFIER TO KEY-KEY-QUALIFIER.                   AFPINDEX
025500     ADD KEY-IEL-LENGTH, KEY-HDR-LENGTH TO                        AFPINDEX
025600                         KEY-TLE-LENGTH GIVING AFPKEY-LENGTH.     AFPINDEX
025700     WRITE KEY-INDEX-RECORD,                                      AFPINDEX
025800       INVALID KEY                                                AFPINDEX
025900        DISPLAY PGMNAME, ' VSAM INDEX INVALID KEY. FILE STATUS ', AFPINDEX
026000                AFPKEY-STATUS, ' VSAM CODES : ',                  AFPINDEX
026100                VSAM-RC, VSAM-FCT-CODE, VSAM-FDBK-CODE;           AFPINDEX
026200                MOVE VSAM-RC TO RETURN-CODE;                      AFPINDEX
026300     END-WRITE.                                                   AFPINDEX
026400     IF NOT AFPKEY-OK THEN                                        AFPINDEX
026500        DISPLAY 'ERROR WRITING VSAM INPUT ' AFPKEY-STATUS;        AFPINDEX
026600     END-IF.                                                      AFPINDEX
026700     MOVE ZERO TO KEY-TLE-LENGTH, KEY-IEL-LENGTH, KEY-PTR.        AFPINDEX
026800     SKIP2                                                        AFPINDEX
026900 2000-INIT-INDEX.                                                 AFPINDEX
027000     EXIT.                                                        AFPINDEX
027100 TITLE 'IEL PROCESSING'.                                          AFPINDEX
027200 3000-PROCESS-IEL.                                                AFPINDEX
027300     MOVE 1 TO TRIPLET-PTR.                                       AFPINDEX
027400     PERFORM UNTIL TRIPLET-PTR >=                                 AFPINDEX
027500                   (AFPINDEX-LENGTH - LENGTH                      AFPINDEX
027600                    OF AFPINDEX-INTRODUCER);                      AFPINDEX
027700* the triplet length is the first byte of the triplet             AFPINDEX
027800       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;            AFPINDEX
027900       MOVE BIN2 TO TRIPLET-LENGTH;                               AFPINDEX
028000* the triplet type is the second byte of the triplet              AFPINDEX
028100       EVALUATE (AFPINDEX-DATA (TRIPLET-PTR + 1 : 1))             AFPINDEX
028200        WHEN TR-SFOF ( 2 : 1)                                     AFPINDEX
028300         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      AFPINDEX
028400         MOVE BIN-4 TO KEY-REC-OFFSET;                            AFPINDEX
028500        WHEN TR-SFEX ( 2 : 1)                                     AFPINDEX
028600         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      AFPINDEX
028700         MOVE BIN-4 TO KEY-REC-EXTENT;                            AFPINDEX
028800        WHEN TR-BYTEX ( 2 : 1)                                    AFPINDEX
028900         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      AFPINDEX
029000         MOVE BIN-4 TO KEY-BYTE-EXTENT;                           AFPINDEX
029100        WHEN TR-BYTEOF ( 2 : 1)                                   AFPINDEX
029200         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      AFPINDEX
029300         MOVE BIN-4 TO KEY-BYTE-OFFSET;                           AFPINDEX
029400        WHEN TR-PGMAP  ( 2 : 1)                                   AFPINDEX
029500         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      AFPINDEX
029600         MOVE BIN-4 TO KEY-MAP-PAGE;                              AFPINDEX
029700        WHEN TR-FQN ( 2 : 1)                                      AFPINDEX
029800* the FQN type is the third byte of the triplet                   AFPINDEX
029900         EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 2 : 1)             AFPINDEX
030000          WHEN FQN-PGRP                                           AFPINDEX
030100           MOVE PAGE-GROUP TO KEY-KEY-TYPE;                       AFPINDEX
030200          WHEN FQN-BPG                                            AFPINDEX
030300           MOVE PAGE-PAGE  TO KEY-KEY-TYPE;                       AFPINDEX
030400         END-EVALUATE;                                            AFPINDEX
030500* FQN contents are always saved in the IEL triplets               AFPINDEX
030600         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO               AFPINDEX
030700              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :              AFPINDEX
030800                                TRIPLET-LENGTH);                  AFPINDEX
030900         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                    AFPINDEX
031000        WHEN OTHER                                                AFPINDEX
031100* Move all other triplets to index record                         AFPINDEX
031200         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO               AFPINDEX
031300              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :              AFPINDEX
031400                                TRIPLET-LENGTH);                  AFPINDEX
031500         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                    AFPINDEX
031600       END-EVALUATE;                                              AFPINDEX
031700       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                         AFPINDEX
031800     END-PERFORM.                                                 AFPINDEX
031900 TITLE 'TLE PROCESSING'.                                          AFPINDEX
032000 4000-PROCESS-TLE.                                                AFPINDEX
032100     MOVE 1 TO TRIPLET-PTR.                                       AFPINDEX
032200     PERFORM UNTIL TRIPLET-PTR >=                                 AFPINDEX
032300                   (AFPINDEX-LENGTH -                             AFPINDEX
032400                    LENGTH OF AFPINDEX-INTRODUCER);               AFPINDEX
032500* the triplet length is the first byte of the triplet             AFPINDEX
032600       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;            AFPINDEX
032700       MOVE BIN2 TO TRIPLET-LENGTH;                               AFPINDEX
032800* the triplet type is the second byte of the triplet              AFPINDEX
032900       EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 1 : 1)               AFPINDEX
033000        WHEN TR-ATVAL ( 2 : 1)                                    AFPINDEX
033100         COMPUTE KEY-LEFT = KEY-MAX - KEY-PTR;                    AFPINDEX
033200         IF KEY-LEFT > (TRIPLET-LENGTH - ATTVAL-OFFSET)           AFPINDEX
033300          THEN                                                    AFPINDEX
033400* move attribute value to right end of key                        AFPINDEX
033500           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :      AFPINDEX
033600                               TRIPLET-LENGTH - ATTVAL-OFFSET)    AFPINDEX
033700                TO KEY-KEY-VALUES (KEY-PTR + 1 :                  AFPINDEX
033800                   TRIPLET-LENGTH - ATTVAL-OFFSET);               AFPINDEX
033900           COMPUTE KEY-PTR = KEY-PTR + TRIPLET-LENGTH -           AFPINDEX
034000                             ATTVAL-OFFSET;                       AFPINDEX
034100         ELSE                                                     AFPINDEX
034200* move as much of attribute value to key as will fit              AFPINDEX
034300           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :      AFPINDEX
034400                               KEY-LEFT) TO                       AFPINDEX
034500                KEY-KEY-VALUES (KEY-PTR + 1 : KEY-LEFT);          AFPINDEX
034600           MOVE KEY-MAX TO KEY-PTR;                               AFPINDEX
034700         END-IF;                                                  AFPINDEX
034800        WHEN OTHER                                                AFPINDEX
034900* Move all other triplets to index record                         AFPINDEX
035000         MOVE AFPINDEX-DATA (TRIPLET-PTR : TRIPLET-LENGTH) TO     AFPINDEX
035100           KEY-TLE-TRIPLETS (KEY-TLE-LENGTH + 1 : TRIPLET-LENGTH);AFPINDEX
035200         ADD TRIPLET-LENGTH TO KEY-TLE-LENGTH;                    AFPINDEX
035300       END-EVALUATE;                                              AFPINDEX
035400       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                         AFPINDEX
035500     END-PERFORM.                                                 AFPINDEX
