000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   APKINDEX
000200 ID DIVISION.                                                     APKINDEX
000300* LAST UPDATE ON 18 Oct 1993 AT 08:21:25 BY  VEND789 VERSION 01 * APKINDEX
000400 PROGRAM-ID. APKINDEX.                                            APKINDEX
000500 AUTHOR. B. E. HAAN, Pennant Systems, IBM                         APKINDEX
000600         H. Turetzky, HYDRA                                       APKINDEX
000700                                                                  APKINDEX
000800     NOTE: REQUIRES VS COBOL II.  This program is a sample exit   APKINDEX
000900     for ACIF (APKACIF,5648-062) demonstrating the use of the     APKINDEX
001000     ACIF index exit.                                             APKINDEX
001100                                                                  APKINDEX
001200     This program must either be compiled with the NORENT option  APKINDEX
001300     or linked with IGZOPT with the RTEREUS option.               APKINDEX
001400     (See VS COBOL II Application Programming Guide, SC26-4045).  APKINDEX
001500                                                                  APKINDEX
001600     This program creates a VSAM index (KSDS) from a MO:DCA       APKINDEX
001700     document index.  There are several ways to organize such an  APKINDEX
001800     index. This program assumes TLE records occur in             APKINDEX
001900     heirarchical order, ie., most signficant first. One index    APKINDEX
002000     record will be created for each page (it is assumed that     APKINDEX
002100     the input index is at page level). We further assume that    APKINDEX
002200     the index is of the style created by ACIF (5648-062).        APKINDEX
002300                                                                  APKINDEX
002400     The values for all of the TLE attribute value triplets are   APKINDEX
002500     placed in the VSAM key, suffixed by a flag indicating if     APKINDEX
002600     the index is for a group or page, and a counter to           APKINDEX
002700     guarantee uniqueness.  Since VSAM limits key length to 255,  APKINDEX
002800     and the value for any attribute value triplet can be 250     APKINDEX
002900     bytes, this scheme is will not handle all possible MO:DCA    APKINDEX
003000     indexes. However, for most purposes this length is adequate  APKINDEX
003100     to hold all the values being indexed.                        APKINDEX
003200                                                                  APKINDEX
003300     The data portion of the VSAM index record contains all of    APKINDEX
003400     the locating information (byte and record offsets) and other APKINDEX
003500     information contained on the page and group IELs, so that    APKINDEX
003600     the MO:DCA index can be reconstructed from the VSAM file.    APKINDEX
003700                                                                  APKINDEX
003800     All of the TLE triplets are saved in the data portion of     APKINDEX
003900     the index record.                                            APKINDEX
004000                                                                  APKINDEX
004100     For cases where this organization is inadequate, such as     APKINDEX
004200     TLEs containing long values, the necessity to search on      APKINDEX
004300     secondary index values, or a different structure in the      APKINDEX
004400     relationship of tag/value pairs, the index could be          APKINDEX
004500     organized as a primary index using the group name, and       APKINDEX
004600     VSAM alternate indexes for each tag. A more flexible         APKINDEX
004700     method would be DB2 tables, where unique relationships       APKINDEX
004800     can be defined between keys.                                 APKINDEX
004900                                                                  APKINDEX
005000     For purposes of demonstrating the use of the index exit,     APKINDEX
005100     this program will, in addition to the above, delete all      APKINDEX
005200     Page IEL records from the ACIF-created index while           APKINDEX
005300     retaining them in the VSAM index. It will alter the BDI      APKINDEX
005400     record to contain a comment triplet.                         APKINDEX
005500                                                                  APKINDEX
005600     Note that a version of this program that processes an ACIF   APKINDEX
005700     index file is available.                                     APKINDEX
005800     EJECT                                                        APKINDEX
005900 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    APKINDEX
006000 DATE-WRITTEN. JUN 93.                                            APKINDEX
006100 DATE-COMPILED.                                                   APKINDEX
006200 SECURITY. IBM SAMPLE CODE ONLY.                                  APKINDEX
006300*/**************************************************************/ APKINDEX
006400*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */ APKINDEX
006500*/*                                                            */ APKINDEX
006600*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ APKINDEX
006700*/*                                                            */ APKINDEX
006800*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ APKINDEX
006900*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ APKINDEX
007000*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ APKINDEX
007100*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ APKINDEX
007200*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ APKINDEX
007300*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ APKINDEX
007400*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ APKINDEX
007500*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ APKINDEX
007600*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ APKINDEX
007700*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ APKINDEX
007800*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ APKINDEX
007900*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ APKINDEX
008000*/**************************************************************/ APKINDEX
008100 TITLE 'AFP INDEX PROCESSOR'.                                     APKINDEX
008200 ENVIRONMENT DIVISION.                                            APKINDEX
008300 CONFIGURATION SECTION.                                           APKINDEX
008400 SOURCE-COMPUTER. IBM-370.                                        APKINDEX
008500 OBJECT-COMPUTER. IBM-370.                                        APKINDEX
008600 INPUT-OUTPUT SECTION.                                            APKINDEX
008700 FILE-CONTROL.                                                    APKINDEX
008800     SELECT AFPKEY-FILE          ASSIGN TO AFPKEY,                APKINDEX
008900                                 ORGANIZATION INDEXED,            APKINDEX
009000                                 ACCESS MODE DYNAMIC,             APKINDEX
009100                                 FILE STATUS AFPKEY-STATUS        APKINDEX
009200                                             VSAM-STATUS,         APKINDEX
009300                                 RECORD KEY KEY-KEY.              APKINDEX
009400   EJECT                                                          APKINDEX
009500 DATA DIVISION.                                                   APKINDEX
009600 FILE SECTION.                                                    APKINDEX
009700 FD  AFPKEY-FILE                 GLOBAL,                          APKINDEX
009800     RECORD VARYING DEPENDING ON AFPKEY-LENGTH.                   APKINDEX
009900     COPY AFPKEY.                                                 APKINDEX
010000   EJECT                                                          APKINDEX
010100 WORKING-STORAGE SECTION.                                         APKINDEX
010200 77  PGMNAME                 PIC X(8) VALUE 'AFPINDEX'.           APKINDEX
010300 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           APKINDEX
010400 77  ABEND-CODE              PIC 9(4) COMP VALUE 12.              APKINDEX
010500 77  SF-CC                   PIC X    VALUE X'5A'.                APKINDEX
010600 77  AFPKEY-LENGTH           PIC 9(8) COMP VALUE 8205.            APKINDEX
010700 77  AFPKEY-STATUS           PIC XX.                              APKINDEX
010800     88  AFPKEY-OK           VALUE '00'.                          APKINDEX
010900 77  AFPKEY-STATUS-NUM       REDEFINES AFPKEY-STATUS              APKINDEX
011000                             PIC 99.                              APKINDEX
011100 77  INDEX-QUALIFIER         PIC 9(8) COMP VALUE ZERO.            APKINDEX
011200 77  PAGE-GROUP              PIC X    VALUE 'G'.                  APKINDEX
011300 77  PAGE-PAGE               PIC X    VALUE 'P'.                  APKINDEX
011400 77  KEY-LEFT                PIC 9(4) BINARY.                     APKINDEX
011500 77  KEY-MAX                 PIC 9(4) BINARY VALUE 255.           APKINDEX
011600 77  KEY-HDR-LENGTH          PIC 9(4) BINARY.                     APKINDEX
011700 77  KEY-PTR                 PIC 9(4) BINARY.                     APKINDEX
011800 77  COMMENT-ID              PIC X(13) VALUE 'MODIFIED BY: '.     APKINDEX
011900 77  IEL-PENDING-FLAG        PIC X    VALUE LOW-VALUE.            APKINDEX
012000     88  IEL-PENDING         VALUE HIGH-VALUE.                    APKINDEX
012100 77  AFPINDEX-EOF-FLAG       PIC X    VALUE LOW-VALUE.            APKINDEX
012200     88  AFPINDEX-EOF        VALUE HIGH-VALUE.                    APKINDEX
012300     SKIP1                                                        APKINDEX
012400 01  VSAM-STATUS.                                                 APKINDEX
012500     05  VSAM-RC                 PIC 9(4) COMP.                   APKINDEX
012600     05  VSAM-FCT-CODE           PIC 9(1) COMP.                   APKINDEX
012700     05  VSAM-FDBK-CODE          PIC 9(3) COMP.                   APKINDEX
012800     SKIP1                                                        APKINDEX
012900 01  DATE-DATA.                                                   APKINDEX
013000   05  RUN-DATE.                                                  APKINDEX
013100     10 RUN-YY                 PIC 99.                            APKINDEX
013200     10 RUN-MM                 PIC 99.                            APKINDEX
013300     10 RUN-DD                 PIC 99.                            APKINDEX
013400   05  COMPILE-DATE.                                              APKINDEX
013500     10  COMP-DATE             PIC X(8).                          APKINDEX
013600     10  COMP-TIME             PIC X(12).                         APKINDEX
013700   05  RUN-TIME.                                                  APKINDEX
013800     10  RUN-HH                PIC 99.                            APKINDEX
013900     10  RUN-MM                PIC 99.                            APKINDEX
014000     10  RUN-SS                PIC 99.                            APKINDEX
014100     10  RUN-MS                PIC 99.                            APKINDEX
014200     SKIP2                                                        APKINDEX
014300 01  BINARY-NUMBERS.                                              APKINDEX
014400     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.      APKINDEX
014500     05  BIN4-X                  REDEFINES BIN-4                  APKINDEX
014600                                 PIC X(4).                        APKINDEX
014700     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.      APKINDEX
014800     05  BIN2-X                  REDEFINES BIN2.                  APKINDEX
014900         10  FILLER              PIC X.                           APKINDEX
015000         10  BIN2-2              PIC X.                           APKINDEX
015100     SKIP2                                                        APKINDEX
015200 01  COMMENT-TRIPLET.                                             APKINDEX
015300     05  COMMENT-LEN         PIC X.                               APKINDEX
015400     05  COMMENT-TYPE        PIC X.                               APKINDEX
015500     05  COMMENT-DATA        PIC X(250).                          APKINDEX
015600     SKIP2                                                        APKINDEX
015700 01  TRIPLET-DATA.                                                APKINDEX
015800     05  TRIPLET-PTR             PIC 9(8) BINARY.                 APKINDEX
015900     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                 APKINDEX
016000* offset to start of attribute value                              APKINDEX
016100     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.         APKINDEX
016200* STRUCTURED FIELD DEFINITIONS                                    APKINDEX
016300     COPY STRFLDS SUPPRESS.                                       APKINDEX
016400 TITLE 'DATA PASSED FROM ACIF'.                                   APKINDEX
016500 LINKAGE SECTION.                                                 APKINDEX
016600                                                                  APKINDEX
016700 01  IDX-PARMS.                                                   APKINDEX
016800     05  IDX-UWORK           POINTER.                             APKINDEX
016900     05  IDX-PFATTR          POINTER.                             APKINDEX
017000     05  IDX-RECORD          POINTER.                             APKINDEX
017100     05  IDX-RECORDLN        PIC 9(4) BINARY.                     APKINDEX
017200     05  IDX-REQUEST         PIC X.                               APKINDEX
017300         88  IDX-USE         VALUE X'00'.                         APKINDEX
017400         88  IDX-DELETE      VALUE X'01'.                         APKINDEX
017500     05  IDX-EOF             PIC X.                               APKINDEX
017600         88  IDX-NOTEOF      VALUE 'N'.                           APKINDEX
017700         88  IDX-EOFLAG      VALUE 'Y'.                           APKINDEX
017800                                                                  APKINDEX
017900 01  IDX-WORKA.                                                   APKINDEX
018000     05  IDX-FIRST-FLAG      PIC X.                               APKINDEX
018100         88  IDX-FIRST       VALUE LOW-VALUE.                     APKINDEX
018200         88  IDX-NOTFIRST    VALUE HIGH-VALUE.                    APKINDEX
018300                                                                  APKINDEX
018400 01  AFPINDEX-RECORD.                                             APKINDEX
018500     05  AFPINDEX-INTRODUCER.                                     APKINDEX
018600       10  AFPINDEX-CC       PIC X.                               APKINDEX
018700       10  AFPINDEX-LEN-CHR  PIC XX.                              APKINDEX
018800       10  AFPINDEX-RECLEN   REDEFINES AFPINDEX-LEN-CHR           APKINDEX
018900                             PIC 9(4) COMP.                       APKINDEX
019000* NOTE:  9(4) COMP is used to get halfword integer, but COBOL     APKINDEX
019100* may restrict value to 9999. COBOL II compile-time parm          APKINDEX
019200* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword     APKINDEX
019300* with no truncation (TRUNC(OPT) produces far better code).       APKINDEX
019400       10  AFPINDEX-TYPE     PIC XXX.                             APKINDEX
019500       10  AFPINDEX-FLAG     PIC X.                               APKINDEX
019600       10  AFPINDEX-SEQ-CHR  PIC XX.                              APKINDEX
019700       10  AFPINDEX-SEQNUM   REDEFINES AFPINDEX-SEQ-CHR           APKINDEX
019800                             PIC 9(4) COMP.                       APKINDEX
019900     05  AFPINDEX-DATA.                                           APKINDEX
020000         10  AFPINDEX-ARRAY      OCCURS 8192,                     APKINDEX
020100                                 DEPENDING ON AFPINDEX-RECLEN,    APKINDEX
020200                                 INDEXED BY AFPINDEX-INDX,        APKINDEX
020300                                 PIC X.                           APKINDEX
020400 TITLE 'INITIALIZATION AND MAIN LINE'.                            APKINDEX
020500 PROCEDURE DIVISION USING IDX-PARMS.                              APKINDEX
020600*  This program is an ACIF index exit. It creates                 APKINDEX
020700* a similar index (AFPKEY) using a VSAM KSDS.  Each IEL starts a  APKINDEX
020800* corresponding new VSAM record, subsequent TLE records that      APKINDEX
020900* REFERENCE the IEL are also accumulated.  When the next IEL is   APKINDEX
021000* encounterd THE prior IEL and TLE's are written to a single VSAM APKINDEX
021100* record.                                                         APKINDEX
021200 000-MAINLINE.                                                    APKINDEX
021300     SET ADDRESS OF AFPINDEX-RECORD TO IDX-RECORD.                APKINDEX
021400     SET ADDRESS OF IDX-WORKA TO IDX-UWORK.                       APKINDEX
021500     MOVE ZERO TO RETURN-CODE.                                    APKINDEX
021600     IF IDX-EOFLAG                                                APKINDEX
021700      THEN                                                        APKINDEX
021800       CLOSE AFPKEY-FILE;                                         APKINDEX
021900       GOBACK;                                                    APKINDEX
022000     END-IF.                                                      APKINDEX
022100                                                                  APKINDEX
022200     IF IDX-NOTFIRST                                              APKINDEX
022300      THEN                                                        APKINDEX
022400       PERFORM 0200-PROCESS-INDEX;                                APKINDEX
022500      ELSE                                                        APKINDEX
022600       PERFORM 0100-INITIALIZE;                                   APKINDEX
022700       SET IDX-NOTFIRST TO TRUE;                                  APKINDEX
022800       PERFORM 0200-PROCESS-INDEX;                                APKINDEX
022900     END-IF.                                                      APKINDEX
023000     SKIP2                                                        APKINDEX
023100 0100-INITIALIZE.                                                 APKINDEX
023200     MOVE WHEN-COMPILED TO COMPILE-DATE.                          APKINDEX
023300     ACCEPT RUN-DATE FROM DATE.                                   APKINDEX
023400     ACCEPT RUN-TIME FROM TIME.                                   APKINDEX
023500        SKIP2                                                     APKINDEX
023600     OPEN OUTPUT AFPKEY-FILE.                                     APKINDEX
023700        SKIP2                                                     APKINDEX
023800     IF (NOT AFPKEY-OK) THEN                                      APKINDEX
023900        DISPLAY PGMNAME,                                          APKINDEX
024000                'AFPKEY  STATUS AFTER OPEN ' AFPKEY-STATUS;       APKINDEX
024100        DISPLAY ' ';                                              APKINDEX
024200        MOVE ABEND-CODE TO RETURN-CODE;                           APKINDEX
024300        GOBACK.                                                   APKINDEX
024400        SKIP2                                                     APKINDEX
024500     ADD LENGTH OF KEY-LOCATION-DATA                              APKINDEX
024600         LENGTH OF KEY-IEL-LENGTH                                 APKINDEX
024700         LENGTH OF KEY-TLE-LENGTH                                 APKINDEX
024800         LENGTH OF KEY-KEY        GIVING                          APKINDEX
024900         KEY-HDR-LENGTH.                                          APKINDEX
025000        EJECT                                                     APKINDEX
025100 0200-PROCESS-INDEX.                                              APKINDEX
025200     SET IDX-USE TO TRUE.                                         APKINDEX
025300     EVALUATE AFPINDEX-TYPE;                                      APKINDEX
025400      WHEN SF-BDI                                                 APKINDEX
025500       PERFORM 2000-INIT-INDEX;                                   APKINDEX
025600      WHEN SF-IEL                                                 APKINDEX
025700       IF IEL-PENDING                                             APKINDEX
025800        THEN                                                      APKINDEX
025900         PERFORM 1100-WRITE-AFPKEY;                               APKINDEX
026000       END-IF;                                                    APKINDEX
026100       PERFORM 3000-PROCESS-IEL;                                  APKINDEX
026200       SET IEL-PENDING TO TRUE;                                   APKINDEX
026300      WHEN SF-TLE                                                 APKINDEX
026400       PERFORM 4000-PROCESS-TLE;                                  APKINDEX
026500      WHEN SF-EDI                                                 APKINDEX
026600       IF IEL-PENDING                                             APKINDEX
026700        THEN                                                      APKINDEX
026800         PERFORM 1100-WRITE-AFPKEY;                               APKINDEX
026900       END-IF;                                                    APKINDEX
027000      WHEN OTHER                                                  APKINDEX
027100       CONTINUE;                                                  APKINDEX
027200     END-EVALUATE;                                                APKINDEX
027300      SKIP2                                                       APKINDEX
027400     GOBACK.                                                      APKINDEX
027500 TITLE 'FILE I/O ROUTINES'.                                       APKINDEX
027600 1100-WRITE-AFPKEY.                                               APKINDEX
027700* Add the record to the VSAM key file, incrementing the qualifier APKINDEX
027800* go guarantee a unique index. If an error occurs, return the     APKINDEX
027900* error code to ACIF to halt processing.                          APKINDEX
028000     ADD 1 TO INDEX-QUALIFIER.                                    APKINDEX
028100     MOVE INDEX-QUALIFIER TO KEY-KEY-QUALIFIER.                   APKINDEX
028200     ADD KEY-IEL-LENGTH, KEY-HDR-LENGTH TO                        APKINDEX
028300                         KEY-TLE-LENGTH GIVING AFPKEY-LENGTH.     APKINDEX
028400     WRITE KEY-INDEX-RECORD,                                      APKINDEX
028500       INVALID KEY                                                APKINDEX
028600        DISPLAY PGMNAME, ' VSAM INDEX INVALID KEY. FILE STATUS ', APKINDEX
028700                AFPKEY-STATUS, ' VSAM CODES : ',                  APKINDEX
028800                VSAM-RC, VSAM-FCT-CODE, VSAM-FDBK-CODE;           APKINDEX
028900     END-WRITE.                                                   APKINDEX
029000     IF NOT AFPKEY-OK THEN                                        APKINDEX
029100        DISPLAY PGMNAME, ' ERROR WRITING VSAM OUTPUT ',           APKINDEX
029200                AFPKEY-STATUS;                                    APKINDEX
029300        MOVE AFPKEY-STATUS-NUM TO RETURN-CODE;                    APKINDEX
029400     END-IF.                                                      APKINDEX
029500     MOVE ZERO TO KEY-TLE-LENGTH, KEY-IEL-LENGTH, KEY-PTR.        APKINDEX
029600     SKIP2                                                        APKINDEX
029700 2000-INIT-INDEX.                                                 APKINDEX
029800     MOVE TR-UCOMMENT (2:1) TO COMMENT-TYPE.                      APKINDEX
029900     ADD LENGTH OF COMMENT-ID, 1 GIVING BIN2.                     APKINDEX
030000     MOVE COMMENT-ID TO COMMENT-DATA.                             APKINDEX
030100     ADD LENGTH OF COMMENT-ID, 1 TO BIN2.                         APKINDEX
030200     MOVE PGMNAME TO COMMENT-DATA (BIN2 : LENGTH OF PGMNAME).     APKINDEX
030300     ADD LENGTH OF PGMNAME, 1 TO BIN2.                            APKINDEX
030400     MOVE RUN-DATE TO COMMENT-DATA (BIN2 : LENGTH OF RUN-DATE).   APKINDEX
030500     ADD LENGTH OF RUN-DATE, 1 TO BIN2.                           APKINDEX
030600     MOVE RUN-TIME TO COMMENT-DATA (BIN2 : LENGTH OF RUN-TIME).   APKINDEX
030700     ADD LENGTH OF RUN-TIME TO BIN2.                              APKINDEX
030800     ADD LENGTH OF COMMENT-LEN, LENGTH OF COMMENT-TYPE TO BIN2.   APKINDEX
030900     MOVE BIN2-2 TO COMMENT-LEN.                                  APKINDEX
031000     MOVE COMMENT-TRIPLET TO AFPINDEX-DATA                        APKINDEX
031100                             (IDX-RECORDLN + 1 : BIN2).           APKINDEX
031200     ADD BIN2 TO AFPINDEX-RECLEN.                                 APKINDEX
031300     ADD BIN2 TO IDX-RECORDLN.                                    APKINDEX
031400     SET IDX-USE TO TRUE.                                         APKINDEX
031500 TITLE 'IEL PROCESSING'.                                          APKINDEX
031600 3000-PROCESS-IEL.                                                APKINDEX
031700     MOVE 1 TO TRIPLET-PTR.                                       APKINDEX
031800     PERFORM UNTIL TRIPLET-PTR >=                                 APKINDEX
031900                   (IDX-RECORDLN - LENGTH                         APKINDEX
032000                    OF AFPINDEX-INTRODUCER);                      APKINDEX
032100* the triplet length is the first byte of the triplet             APKINDEX
032200       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;            APKINDEX
032300       MOVE BIN2 TO TRIPLET-LENGTH;                               APKINDEX
032400* the triplet type is the second byte of the triplet              APKINDEX
032500       EVALUATE (AFPINDEX-DATA (TRIPLET-PTR + 1 : 1))             APKINDEX
032600        WHEN TR-SFOF ( 2 : 1)                                     APKINDEX
032700         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      APKINDEX
032800         MOVE BIN-4 TO KEY-REC-OFFSET;                            APKINDEX
032900        WHEN TR-SFEX ( 2 : 1)                                     APKINDEX
033000         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      APKINDEX
033100         MOVE BIN-4 TO KEY-REC-EXTENT;                            APKINDEX
033200        WHEN TR-BYTEX ( 2 : 1)                                    APKINDEX
033300         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      APKINDEX
033400         MOVE BIN-4 TO KEY-BYTE-EXTENT;                           APKINDEX
033500        WHEN TR-BYTEOF ( 2 : 1)                                   APKINDEX
033600         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      APKINDEX
033700         MOVE BIN-4 TO KEY-BYTE-OFFSET;                           APKINDEX
033800        WHEN TR-PGMAP  ( 2 : 1)                                   APKINDEX
033900         MOVE AFPINDEX-DATA (TRIPLET-PTR + 2 : 4) TO BIN4-X;      APKINDEX
034000         MOVE BIN-4 TO KEY-MAP-PAGE;                              APKINDEX
034100        WHEN TR-FQN ( 2 : 1)                                      APKINDEX
034200* the FQN type is the third byte of the triplet                   APKINDEX
034300         EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 2 : 1)             APKINDEX
034400          WHEN FQN-PGRP                                           APKINDEX
034500           MOVE PAGE-GROUP TO KEY-KEY-TYPE;                       APKINDEX
034600          WHEN FQN-BPG                                            APKINDEX
034700           MOVE PAGE-PAGE  TO KEY-KEY-TYPE;                       APKINDEX
034800* For this example, we delete the Page IELs.                      APKINDEX
034900           SET IDX-DELETE TO TRUE;                                APKINDEX
035000         END-EVALUATE;                                            APKINDEX
035100* FQN contents are always saved in the IEL triplets               APKINDEX
035200         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO               APKINDEX
035300              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :              APKINDEX
035400                                TRIPLET-LENGTH);                  APKINDEX
035500         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                    APKINDEX
035600        WHEN OTHER                                                APKINDEX
035700* Move all other triplets to index record                         APKINDEX
035800         MOVE AFPINDEX-DATA (1 : TRIPLET-LENGTH) TO               APKINDEX
035900              KEY-IEL-TRIPLETS (KEY-IEL-LENGTH + 1 :              APKINDEX
036000                                TRIPLET-LENGTH);                  APKINDEX
036100         ADD TRIPLET-LENGTH TO KEY-IEL-LENGTH;                    APKINDEX
036200       END-EVALUATE;                                              APKINDEX
036300       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                         APKINDEX
036400     END-PERFORM.                                                 APKINDEX
036500 TITLE 'TLE PROCESSING'.                                          APKINDEX
036600 4000-PROCESS-TLE.                                                APKINDEX
036700     MOVE 1 TO TRIPLET-PTR.                                       APKINDEX
036800     PERFORM UNTIL TRIPLET-PTR >=                                 APKINDEX
036900                   (IDX-RECORDLN -                                APKINDEX
037000                    LENGTH OF AFPINDEX-INTRODUCER);               APKINDEX
037100* the triplet length is the first byte of the triplet             APKINDEX
037200       MOVE AFPINDEX-DATA (TRIPLET-PTR : 1) TO BIN2-2;            APKINDEX
037300       MOVE BIN2 TO TRIPLET-LENGTH;                               APKINDEX
037400* the triplet type is the second byte of the triplet              APKINDEX
037500       EVALUATE AFPINDEX-DATA (TRIPLET-PTR + 1 : 1)               APKINDEX
037600        WHEN TR-ATVAL ( 2 : 1)                                    APKINDEX
037700         COMPUTE KEY-LEFT = KEY-MAX - KEY-PTR;                    APKINDEX
037800         IF KEY-LEFT > (TRIPLET-LENGTH - ATTVAL-OFFSET)           APKINDEX
037900          THEN                                                    APKINDEX
038000* move attribute value to right end of key                        APKINDEX
038100           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :      APKINDEX
038200                               TRIPLET-LENGTH - ATTVAL-OFFSET)    APKINDEX
038300                TO KEY-KEY-VALUES (KEY-PTR + 1 :                  APKINDEX
038400                   TRIPLET-LENGTH - ATTVAL-OFFSET);               APKINDEX
038500           COMPUTE KEY-PTR = KEY-PTR + TRIPLET-LENGTH -           APKINDEX
038600                             ATTVAL-OFFSET;                       APKINDEX
038700         ELSE                                                     APKINDEX
038800* move as much of attribute value to key as will fit              APKINDEX
038900           MOVE AFPINDEX-DATA (TRIPLET-PTR + ATTVAL-OFFSET :      APKINDEX
039000                               KEY-LEFT) TO                       APKINDEX
039100                KEY-KEY-VALUES (KEY-PTR + 1 : KEY-LEFT);          APKINDEX
039200           MOVE KEY-MAX TO KEY-PTR;                               APKINDEX
039300         END-IF;                                                  APKINDEX
039400        WHEN OTHER                                                APKINDEX
039500* Move all other triplets to index record                         APKINDEX
039600         MOVE AFPINDEX-DATA (TRIPLET-PTR : TRIPLET-LENGTH) TO     APKINDEX
039700           KEY-TLE-TRIPLETS (KEY-TLE-LENGTH + 1 : TRIPLET-LENGTH);APKINDEX
039800         ADD TRIPLET-LENGTH TO KEY-TLE-LENGTH;                    APKINDEX
039900       END-EVALUATE;                                              APKINDEX
040000       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                         APKINDEX
040100     END-PERFORM.                                                 APKINDEX
